ThumbHTML - Introduction

ThumbHTML v2.7

This program helps you to generate quick HTML pages of your digital photographs.
To create your web photo album in just FOUR steps:

  • Browse to the folder containing your originals
  • Click the "Batch Process" button on the main Thumbnails tab.

When the images have been resized according to the default settings, the program wil automatically display the HTML tab, and display a message box.

  • Enter a title into the appropriate box and
  • Click the "Make HTML" button, and that's it!
  • Click the 'View pages in browser' link to see what the album looks like.
All that remains is to upload the contents of the folder (including the sub-folders) to your web server or ISP account.
For more details, follow one of these links...

Quick-Start
Detailed Step-by-step guide

1: Resizing Your Main Images ...
  • Structuring your photo folders
  • Creating thumbnails (and other sizes)
  • Drop shadows and background colours
  • Batch processing
  • Adding a text watermark
  • Additional image processing functions
2: Adding Picture Information
  • Adding picture comments
3: Creating Your Web Pages
  • Choosing colours
  • Choosing styles
  • Providing photo details
  • Sorting the images
  • Custom footers
  • Generating the HTML pages
  • Creating a slide-show
4: General
  • Creating custom profiles
  • Creating custom templates
  • Viewing EXIF Data
  • Future plans
5: Other
  • Example of exported EXIF data
  • Example of exported picture data
  • Default thumbnail template
  • Default linked image template
  • Default slideshow template
© Jeff Waldock
February 2003 		Homepages: ThumbHTML
Landscapeimage.com 		Revision history
Future plans


ThumbHTML - Quickstart

ThumbHTML v2.7 - Quick Start
STEP 1
Using the drive and directory controls on the main screen, find the folder containing the image files you want to process.

STEP 2
Select the images in that folder you want to process. The image filenames appear in the listbox, and all are selected by default. You can de-select individual images by clicking on the checkbox to the left of each filename. You can also select ALL or NONE by using the marked buttons. If you do not want to overwrite existing image files in the target folder (see next section), uncheck the box marked "Overwrite existing thumbnails". You can choose to include JPG, PNG and/or BMP files.

STEP 3 (the THUMBNAILS tab)
Choose a thumbnail folder name and thumbnail size (in pixels) - the defaults are 'thumb' and '150' respectively.
The 'Drop Shadow' option is selected by default. De-select it if you do not want this. The default background colour is white - use the colours tab to change this if you want a different colour.

STEP 4
The "Create nn Thumbnails" button will indicate the number of suitable images in the selected folder. Click this to create the thumbnails (it will be disabled if there are none).
From version 2.2, you can now streamline the process by clicking the 'Batch Process' button. This will automatically generate a set of thumbnails and a set of 600 pixel images to be the 'linked images'.

STEP 5 (the HTML tab)
Enter the number of images required per page, and the desired page title.
Click on the 'Make HTML' button.

STEP 6
That's it! The html file (or files) can be found in the main folder. Open index.html in your browser.
HTML files will be created in the same folder as your main images; the first file will be called index.html, and the others will be called thumb2.html, thumb3.html etc. All necessary links will have been created between them, so that all you need to do is to point your browser at the URL representing this folder. For example, if your webspace has a URL of http://myserver.com and you have copied the files to a directory within this called, say, /photos/25Dec2001 then the photos will be available from a URL of http://myserver.com/photos/25Dec2001/ (remember the trailing /)
If you use webspace provided by an ISP, say, you will need to transfer all files to your server space. You will need to copy all files fron the main folder you have selected, together with the sub-folder containing the thumbnails.

Back to the main page
© Jeff Waldock
February 2003 		Homepages: ThumbHTML
Landscapeimage.com 		Revision history


ThumbHTML - Step-by-Step

ThumbHTML v2.7 - Detailed Step-by-Step Guide
Text in this colour signifies steps that are optional
STEP 1
Using the drive and directory controls on the main screen, find the folder containing the image files you want to process.

STEP 2
Select the images in that folder you want to process. The image filenames appear in the listbox, and all are selected by default. You can de-select individual images by clicking on the checkbox to the left of each filename. You can also select ALL or NONE by using the marked buttons. If you do not want to overwrite existing image files in the target folder (see next section), uncheck the box marked "Overwrite existing thumbnails". You can choose to include JPG, PNG and/or BMP files.
If you want to alter to default order (alphabetical), click on the 'Sort' button.
(for more information, see the topic Sorting the order of the images).

STEP 3 (the THUMBNAILS tab)
Choose a thumbnail folder name and thumbnail size (in pixels) - the defaults are 'thumb' and '150' respectively.
Select the 'Drop Shadow' option if desired. If you do, you can additionally select the shadow blur level, and the angle, offset and colour (defaults: 75%, 135 degrees, 5 pixels and Black, respectively).
The checkbox marked "100%" is to allow the addition of a drop-shadow to an image without resizing - so the drop-shadow items are automaticaly enabled.

STEP 4 (the STYLES tab) (optional)
If desired, you can change the default colours used in the HTML.
Select the 'Styles' tab, click on the item whose colour you wish to change - this brings up the colour picker window (choose either the web-safe palette - more or less guaranteed to work OK - or you can opt for the greater flexibility offered by the 'Named Colours' palette).
Choose a colour from the popup colour-picker - you can see the effect by looking at the text box displayed.
The background colour chosen here is used for page background and, if the drop shadow option is selected, the background of the thumbnails
You can opt for a background image rather than a solid colour if you check the box near the bottom of the tab.

If you check the 'User-defined stylesheet' box, even more flexibility is offered by letting you pick the style of all the HTML elements used in the web pages created.

STEP 5 (the SETTINGS tab) (optional)
You can change the Jpeg quality setting from its default of 95% and choose to generate a progressive JPG image (although this takes about 20% more time).
Select the 'Special Filter' option if desired. Note that selecting a filter slows the process down considerably (by a factor of between 5 and 8).
You can choose dates to be in the European (default) or US date format, or specify your own, using the 'normal' placeholders of d,m,y for day month and year, etc.

STEP 6
The "Create nn Thumbnails" button will indicate the number of suitable images in the selected folder. Click this to create the thumbnails (it will be disabled if there are none).
Clicking the "Create nn Thumbnails" button will generate thumbnails of these image files, in the folder selected of the size specified. As stated earlier, if you do not want to overwrite existing files, de-select the checkbox marked "Overwrite existing thumbnails"
NB: When clicking on filenames in the listbox, currently existing thumbnails will be displayed - if there is no thumbnail currently, a message will be shown.
Note 1: you can also use the 'Batch process' button to generate your pre-defined folders and image sizes in one go.
Note 2: you can add a watermark to the images created by the program (see the topic Adding a text watermark to your images).

STEP 7 (the HTML tab)
Enter the number of images required per page, and the desired page title.
Choose whether or not to add navigation buttons (these allow you to move between the pages for individual images without having to return to the thumbnails page), and select other checkboxes as appropriate (the functions SHOULD be self-explanatory!)
Click on the 'Make HTML' button.

STEP 8
That's it! The html file (or files) can be found in the main folder. Open index.html in your browser.
HTML files will be created in the same folder as your main images; the first file will be called index.html, and the others will be called thumb2.html, thumb3.html etc. All necessary links will have been created between them, so that all you need to do is to point your browser at the URL representing this folder. For example, if your webspace has a URL of http://myserver.com and you have copied the files to a directory within this called, say, /photos/25Dec2001 then the photos will be available from a URL of http://myserver.com/photos/25Dec2001/ (remember the trailing /)
If you use webspace provided by an ISP, say, you will need to transfer all files to your server space. You will need to copy all files fron the main folder you have selected, together with the sub-folder containing the thumbnails.

Back to the main page
© Jeff Waldock


ThumbHTML - History

ThumbHTML - Revision History
2.7.1 (4 February 2003)
  • EXIF data can now be exported to Excel
  • Custom footer now added to each of the templates. Can contain other macros, since this element is replaced first by ThumbHTML when creating the web pages.
  • Dates now update immediately on selection of different date format.
  • Added context-sensitive help (when pressing F1) to many elements of the program.
  • Added confirm dialog before exit when pressing <Esc>
  • Further updates of help file
  • Some minor interface tweaks
  • Bug Fix - removed 256 character limitation in length of footer.
Version 2.7 - (01/02/2003)
  • Redesigned the way the program deals with EXIF data and picture comments.
  • Automatically extracts any EXIF data found to a file exifdata.txt.
  • User can choose to save all picture information to a file picturedata.txt
  • Can now view all EXIF data while browsing images in the program (check menu item under 'Tools')
  • Program now uses a style sheet for its web pages (photos.css). You can either use a custom style sheet (simple editor provided) or let the program create one from the settings chosen by the user. Tab title changed from 'Colours' to 'Styles'.
  • Another big change is that user templates are now provided for each of the three types of web page ThumbHTML provides (Thumbnails, Linked-Images and Slideshow).
  • Option provided on Tools menu to regenerate the default templates, if you have messed up!
  • Linked to the last point is the fact that edited footers are now redundant, being replaced by the text in the templates.
  • Added a link on the Slideshow tab to display the slideshow in the default browser (disabled if the slideshow file is not present in the current folder)
  • Help file updated
Version 2.6.2 - (18/01/2003)
  • Added a link on the HTML tab to display the web album in the default browser (disabled if an index.htm or index.html file is not present in the current folder)
  • Added new ISEffects library to provide improved drop-shadowing. Features include user-specified shadow size, colour, angle and blur.
  • Updated ImageSource library function - providing speed increase of approx 30% on filtered resizes.
  • Added a link to the users' forum.
  • Bug Fix: Images which had been modified (and in which the EXIF data had therefore been changed or deleted) sometimes caused the appearance of an error box "5 - invalid procedure call or argument" when creating HTML pages. This has now been fixed.
  • Fixed the display of thumbnails on the main tab. Images that had been rotated displayed oddly, and for images where no EXIF data are available, any existing thumnail is used instead.
  • Bug Fix: Problem with file extensions being incorrect case - always converted to lower case after thumbnail is created. This was causing problems when files uploaded to UNIX server.
  • Bug fix: slideshow filename extension was not saved correctly (always .htm)
Version 2.6.2 - (09/01/2003)
  • Added new ISEffects library to provide improved drop-shadowing. Features include user-specified shadow size, colour, angle and blur.
  • Updated ImageSource library function - providing speed increase of approx 30% on filtered resizes.
  • Bug Fix: Problem with file extensions being incorrect case - always converted to lower case after thumbnail is created. This was causing problems when files uploaded to UNIX server.
  • Bug fix: slideshow filename extension was not saved correctly (always .htm)
Version 2.6.0 - (01/01/2003)
  • New year, new version! There has been a major change to the image processing routines, due to an upgrade in the ImageSource library from version 2.2 to 3.0. This has involved a lot of internal re-writing, and there MAY be new bugs introduced. I have checked for this, but ...!

    • Other changes:
  • A different algorithm for creating drop-shadows has been introduced. A shadow is now created offset by a user-specified amount from the image, with the rest of the background filled in with the currently chosen background colour. The shadow can be blurred a user-specified amount (1-100%) - the default is 75%
  • A more fully-featured editor for the user-footer has been added (see the relevant menu item)
  • Additional image-processing features have been added: the ability to create a greyscale image, and to apply a tint (can produce sepia-style images for example), and the ability to apply a sharpening filter (use sparingly, particularly with small images)
  • Speeded up display of thumbnails in main screen, and in the Picture Info dialog, by using the thumbnails embedded in the EXIF data of JPG files, whenever available.
  • Other cosmetic changes to the front-end designed to make usage more straightforward
Version 2.5.0 - (15/12/2002)
  • Major new feature - PROFILES.
    The program now allows you to save 'profiles' - i.e. groups of settings that you want to be able to recall later. Included in the profile is the batch file settings and user-defined footer. This information is saved to files kept in a sub-folder called 'profiles' within the ThumbHTML folder, each using the chosen profile name as the filename. Profiles can be added, selected and deleted by means of the new 'Profiles' menu item.
  • General settings (last-used profile, auto-save profile on exit and auto-load last profile on restart) now saved in a NEW ThumbHTML.ini file in the program folder.
Version 2.4.2 - (08/12/2002)
  • Added ability to choose date format. Default is European, alternative is US format, otherwise you can choose your own format, using the usual placeholder characters of dd,mm,yy etc. (Robert Gusick)
Version 2.4.1 - (27/11/2002)
  • Fixed EXIF image date to be the date of the original image, rather than date last modified (Eirik Ora)
  • Fixed crash when trying to access an empty A: drive (Peter van Lune)
  • Added the ability to choose a background image instead of a background colour (Radu Catina, Georg Reichard, Peter van Lune)
Version 2.4.0 - (16/11/2002)
  • Fixed bug in reading EXIF data, where picture information did not appear to be extracted from the image. This occurred for filenames > 20 characters. I have now increased the filename field to 30 characters. (Eirik Ora)
  • Fixed bug in the slideshow applets in which an incorrect backslash '\' was inserted before filenames in the 'root' folder (Eirik Ora)
  • Fixed bug in which the 'html' part of filenames was missing - this was a bug introduced earlier when I enabled either .htm or .html extensions!
  • Fixed bug giving "Error 6, Overflow" caused by the shutter speed element of the EXIF array containing a number > 32767 (hence outside the integer limit) (Ng)
  • Added a checkbox to allow the use of either .htm or .html for html pages (Martin Briscoll)
  • Added a checkbox to choose linked images to appear in pop-up windows rather than in the same window (Exec)
  • Added a checkbox to the HTML tab to allow users to choose whether or not to add links to the full-size images. (Derran)
Version 2.3.2 - (14/09/2002)
  • Added a 'back' image as well as a 'home' image to the individual html pages so that you can return to the previous thumbnail page, as well as to the index page (thanks to Radu Catina for the suggestion)
  • Modified the watermark dialog so that when selecting one of the 9 regions in which to place the watermark, the default X and Y offsets change accordingly.
Version 2.3.1 - (08/09/2002)
  • Fixed bug in which files in the 'main' folder, with file extensions of .jpg, were being referred to within the HTML with an extension of .JPG. This caused a problem when uploading to UNIX servers where case-sensitivity is an issue. (Thanks to Chris Barrett for pointing this out).
Version 2.3 - September 2002
  • Added a text watermarking facility. You can now specify text to overlay on your images, and choose its position, size, colour and transparency. The text can include 'macro' keywords so that, for example, the filename and/or date can be automatically added.

  • Added a facility to choose the order in which the images are presented. Foremerly, the images were simply presented in the order in which they are automatically sorted (i.e. alphabetically by filename). Now, it is possible to select the order yourself. You can drag and drop thumbnails until they are in the desired order.

  • Choose the colours of the various HTML elements within the program. Previously the program let you select the foreground and background colours; other colour elements could be selected by manually editing the ThumbHTML.ini file. The program now provides the ability to select these interactively. These choices are saved when you exit the program.

Version 2.2.2 - (27/08/2002)
Bug Fixes:
  • Fixed bug reported by Peter Smit in which the case of the HTML filename was incorrect in the navigation link between individual image pages.

  • Fixed incorrect HTML in the navigation links in the individual-image HTML pages. Superfluous tags were being added when no hyperlink was required (for the first and last images).

  • Fixed bug giving rise to runtime error 68 (Device unavailable) or 76 (Path not found) on startup. This was caused by the previous folder having been deleted by the user - the program could not then find this when starting up! It now traps this error, gives a warning message, and sets the startup folder as the program folder.

Version 2.2 - August 2002
  • 09 Aug 02: Added navigation buttons to individual HTML pages to allow users to move directly from one to another without naving to return to the thumbnails page. This feature is enabled by default but can be turned off from the HTML tab. (Thanks to Reinoud Hermans for the suggestion)

  • 09 Aug 02: Added checkboxes to the HTML tab to choose whether or not to add the image number and/or filename to the individual web pages. (Thanks to Steve Acup for the suggestion)

  • 09 Aug 02: Added a batch resize facility. This allows you to pre-define a set of folders (and image sizes) to be created in a one-click process. The action can be initiated via the 'Batch Process' button and customised via the relevant menu item - see the 'Tools' menu. The details of the settings are stored in batch.txt - a text file located in the ThumbHTML folder (Thanks to Tommy Vornanen for the suggestion)

  • 10 Aug 02: Modified slideshow facility so that you can optionally choose to add some, all or none of the following: image comments, image date/time, photo details, filenames and image count. These change dynamically along with the image. The choice of photo details is taken from the EXIF choices available via the menu.

  • 10 Aug 02: The user can now choose to use the datestamp of the image file, rather than the EXIF or camera data, for the image date/time.

  • 10 Aug 02: The user can now choose to add the image count to the slideshow (e.g. 4 of 42).

FIXED:
The program incorrectly added backslashes rather than forward slashes to URLs - this has now been corrected (thanks to Reinoud Hermans for spotting this)

The program now correctly replaces newlines in picture comments with <br> tags for display in the HTML pages (Steve Acup).

Version 2.1 - February 2003
Due to some problems using a separate DOS program to extract the EXIF data from JPG images, this has now been replaced by a function incorporated into the main program. Also, a new menu item (choose EXIF data, on the Tools menu) was added to allow users to decide which of the additional elements of picture information to add to their HTML pages.

Version 2.0 - May 2002
There have been many changes introduced in ThumbHTML both as a result of requests received, and for my own personal needs! These are summarised below, (together with an acknowledgement of the suggestee(s)!):
  • A facility to add comments to images (Astrid van der Knaap and Bill Weide)
    This has been a pressing need for some time! The program has a menu option which allows to generate a comments file, which is saved in the current folder.
    For more details on the comments feature, click here; for more information about the recommended file structures used by ThumbHTML, click here.

  • Linked image pages (me)
    Previously, image thumbnails were linked directly to the 'raw' image. This has now been changed - ThumbHTML generates an additional HTML page for each image, containing image information (see below), and comments, using the selected colour scheme. In order to assist this, and other new features to work successfully, some 'rules' are now recommended with regard to the naming of sub-folders of the image directory. Click here for full details. [Example]

  • Inclusion of Image Data (Steen Traberg-Borup)
    As indicated above, image data are now included in the linked pages. This information is taken from either the file INFO.TXT, generated automatically by Nikon digital cameras, if it is found in the current folder, or if not, the required picture information is extracted directly from the EXIF header embedded in the JPG images. Clearly, this is not possible if the images in question are not JPEGs! - in this case, no image data are retrieved.
    Click here for full details.

  • Slideshow (Astrid van der Knaap)
    ThumbHTML now allows you to generate a slideshow of your images. This only works on IE5, IE6 and NS6 and above (but this covers a fair proportion of current browsers in use!). You can select a title, the delay between images and the transition time.
    Click here for full details.

  • Page colours user-definable (Scott Kurtzeborn)
    In addition to choosing the foreground and background colours by using the colour-picker, it is now possible to specify the ALINK, VLINK and LINK colours, as well as the colours used for photo data, the image date and the footer elements.
    Click here for full details

  • Other changes

    • Other smaller changes are:
    • Can choose thumbnails to be formatted in a table, or free-form
    • ThumbHTML can optionally remember the last folder used
    • Settings are saved each time the program closes. Can reset to program defaults if desired.
    • You can add a user-defined footer to each page.

Version 1.4 - January 2002
In response to a number of requests, the program now makes thumbnails and HTML pages of PNG and BMP files as well as JPG files. Thumbnails are still in JPG format, however.
It is not possible to include GIF files due to the licensing restrictions imposed by Unisys, who hold the patent to the algorithm used in compressing GIF files.
The program also checks to see if the thumbnails of all selected images are present in the named thumbnail folder, and gives an error message if this is not the case.
Thirdly, the technique used for determining image sizes when creating the HTML pages has been re-written, speeding this up so that the process is now almost instantaneous.

Version 1.3.1 - December 2001
A change has been made to improve the way ThumbHTML handles the thumbnail folders.
Previously, when creating HTML pages, the program looked specifically for a sub-folder called "thumb" - this has now been changed and the program will use whatever is currently entered into the "Sub-Directory Name" textbox on the "ThumbNails" tab.
Also, the program now checks to make sure that the filenames in the thumbnails folder match those in the main image directory - if a mismatch is found then a warning message is given and the HTML functions are disabled. The program will re-check whenever (a) a new folder is selected, (b) a new sub-directory name is entered or (c) when a new tab is chosen.

Version 1.2 - October 2001
In response to several requests, added the ability to select a sub-set of images in a folder to be used for the HTML pages. Also tweaked the user interface to make it (hopefully!) clearer, as follows:
1. Removed exit button (replaced by menu and keypress -ESC).
2. Removed help icon (replaced by menu and keypress - F1).
3. Updated the help file, and changed it from RTF to CHM.
4. Made the HTML section of the page enabled/disabled rather than visible/invisible.
5. Added a checkbox to allow users to choose whether or not to overwrite existing thumbnails

Version 1.3 - November 2001
Firstly, I have added the ability to not resize files - this is to allow images to just be given a drop-shadow. Note, however, that this does add a few pixels to two edges to make room for the shadow.
Secondly, the following settings are now user-selectable:
1. The shadow size, in pixels. This was previously set to 10 (still the default).
2. JPEG quality setting (previously 95%, still the default).
3. The shadow position (default is bottom right).
4. Progressive JPG (true/false). Default true.
5. Apply blur (default false).
Thirdly, I have made a few cosmetic changes - the increased number of settings have necessitated a re-arrangement. I have added a tabbed dialog to avoid the screen becoming too cluttered. The settings can be saved to a local .ini file by pressing the button on the 'settings' tab. A status bar has also been added, and used to provide a few additional help hints.
Lastly, this help file has been updated.

Version 1.1 - April 2001
Added ability to create drop shadows, and to use different re-sizing algorithm.
Also provided colour pickers in web-safe and named-colour palettes.

Version 1 - January 2001
Basic program with ability to create thumbnails of a fixed size.

Back to the main page
© Jeff Waldock


ThumbHTML - Structure

ThumbHTML v2.7 - Structure
Directory Structure

One of the changes introduced in Version 2 has been to improve the linked pages. Previously each thumbnail was linked to a raw image file, so that when you click on it the image (however large or small it may be) appears in the browser window. In this version, ThumbHTML creates a new HTML page for each image. This is a much better solution, since the page can include other information, such as the photo data and image comments, and can use the user-chosen title and colour scheme, but it has consequently become necessary to recommend a few naming rules:
  1. The program expects to find the thumbnails used on the thumbnail page in a folder called 'thumb'.

  2. The images used on the linked pages should be in a folder called 'main' - it is recommended that these should be 600 pixels in size. If a folder with this name is not found, the program will use the images in the 'root' folder.

  3. Other sizes should be in folders with the name giving the size - e.g. 400, 900, 1200 etc. The program will provide links to these other sizes on the individual web page. A link to the 'full' size images in the root folder will also be added.

ROOT FOLDER (containing original images)
thumb
main
200
400
900
1200
...
Back to the main page
© Jeff Waldock


ThumbHTML - Resizing Images

ThumbHTML v2.7 - Creating Thumbnails
Creating Thumbnails (and other sizes)

One of the first tasks in generating your web photo album, is to create resized versions of your original images. For obvious reasons, you should always keep your originals untouched - never replace them with image-processed copies. At the very least, you'll probably lose all of the embedded EXIF data, but you will probably also irretrievably lose some picture information.

ThumbHTML allows you to create sub-folders containing copies of these original images resized according to your specifications. The controls on the Thumbnails tab (below) provide you with the means to do this.

The program expects that you will at least create a sub-folder called 'thumb' containing thumbnail-sized copies (say 150-pixel size) and another called 'main' with 600-pixel size copies. The default setting of the 'Batch Resize' function is set up to generate these automaticaly, but you can customise the setting. You might also wish to create drop-shadows on these resized images by checking the drop shadow box. Other sizes can also be created (choose a suitable name for the folder in which to store these - I suggest simply using the image size as the folder name) but you should not generate these with drop-shadows, since the program will be providing a simple link to these, rather than creating an individual HTML page, as it does with those stored in 'main' (used as the images linked to by clicking on the thumbnails).

You may also wish to experiment with the settings in the 'extra' section. You can create monochrome images and apply a coloured tint (this works best when applied to monochrome images). Sharpening can also be selected if required, but be sparing in it's use - too high a setting can introduce undesirable artifacts.

Back to the main page
© Jeff Waldock


ThumbHTML - Drop Shadows

ThumbHTML v2.7 - Drop-Shadows
Creating Drop-Shadows

Suitable use of drop-shadows can considerably enhance the appearance of your web-based photo albums.
The program allows you to do this by checking the appropriate box, and selecting a suitable blur level. You can also select an 'offset' - this is the number of pixels by which the shadow is displaced from the main image.

Unless you want a 'sharp' shadow, you will need to blur it - the suggested figure is 75%.

The colour used for the background of the shadowed image will be that selected from the colours tab for the background of the HTML pages. This is so that the shadowed image will look 'right' on the web page. Since only the thumb and main images are shown on web page backgrounds, it is not therefore advisable to create drop-shadows on any other resized images unless you are doing so for a particular purpose!

Back to the main page
© Jeff Waldock


ThumbHTML - Batch Resize

ThumbHTML v2.7 - Batch Processing
Batch Processing

A new feature, introduced in ThumbHTML 2.2, is the ability to carry out a 'batch' process of your images. This means that you can pre-define a set of sub-folder names and image sizes to be created, and the program will generate the whole set in one go.

The program comes with a default set comprising the 'thumb' folder, with images resized to 150 pixels, and a 'main' folder, with images set at 600 pixels. You should treat this as the bare minimum. Further folders can be added via the "Tools","Set up batch processing" menu option:

Batch processing dialog

As you can see, You can add extra folders by selecting the 'Add New' button. Click OK to accept the selection (the details are saved in batch.txt).

You can remove folders from the batch set by erasing both boxes and clicking OK.

Back to the main page
© Jeff Waldock


ThumbHTML - Watermarking

ThumbHTML v2.7 - Watermarking
Adding a Text Watermark to your Images

You can now add a text watermark to the images created by ThumbHTML. You must first define the watermark you wish to add. You can do this by selecting the appropriate menu item, or by checking the 'Add Watermark' checkbox - if a watermark has not been defined, the following dialog box will appear:

The watermark text is added in the first textbox. In the example shown, you can also see the use of some 'macro' commands, that will automatically add the corresponding information when the watermark is created. Some of these can be interpreted immediately (and are shown in the 'Sample' text at the bottom of the dialog). Others, such as the filename, need to be interpreted during the course of execution of the program.
Most of these 'macro' commands are defined by square brackets (e.g.[date]), but one special case is defined by curly brackets - this allows you to use the standard Windows date/time-specifiers, such as {dddd, d mmm yyyy} to represent, say, Sunday, 1 Sep 2002.
A full list of the commands currently supported is available by passing your mouse over the 'codes' text:

As is evident from the dialog, you also can specify which of the given 9 positions the text is to appear in, the font to be used (this list will vary according to the fonts you have installed on your computer), the text height (in pixels), the text offset, the text colour, the smoothing factor and the transparency.

It is recommended that you do not add watermarks to the small thumbnails - reserved this feature for the larger images (e.g. 400 pixels and above). You will have to experiment with the settings, but a good starting point for 600 pixel images say, is a font height of 10 pixels, a font colour of black and a transparency setting of 80%. The font-smoothing is best left at the default setting of 4, since the text tends to look very 'blocky' otherwise.

The text offset is important - the default position (top-right) needs the x-offset to be negative (otherwise the text finishes right at the edge of the image) and the y-offset to be positive (to move the text down from the top edge of the image). Again, some experimentation may be needed, but the defaults of -10 and 10, respectively, seem about right.
Back to the main page
© Jeff Waldock


ThumbHTML - Extra features

ThumbHTML v2.7 - Extra Features
Extra Image-Processing Features

ThumbHTML version provides FOUR additional image processing features that you might find useful, if used sparingly.

Sharpening | You can choose to sharpen resized images, by checking the checkbox. Select a sharpening amount (default 10%) - you will need to experiment to find the right level.
Greyscale | This is a simple checkbox - when checked, ThumbHTML will generate monochrome images.
Apply Tint | This allows you to add a coloured tint to your images. Works best when used in conjunction with monochrome images. The 'default' settings of 127 for Red, Green and Blue channels will have NO EFFECT! You must modify these!! Increase the red level to get a red tint, for example, but you will not need to do so by much. Click the 'Sepia' button to apply pre-defined settings which will generate a sepia tint.
Border | You can add a border, choosing the size (in pixels) and the colour. Currently, this setting will not function if you also choose a drop-shadow - the drop-shadow will 'override' the border. Actually, it doesn't make a lot of sense to have both anyway.

Back to the main page
© Jeff Waldock


ThumbHTML - Picture Comments

ThumbHTML v2.7 - Picture Comments
Adding and Editing Picture Comments

It is easy to modify picture comments in ThumbHTML. Simply select this item from the Tools menu, and use the editor - it's very self-explanatory. The main editor window looks like this..

When you click 'Done', a file called Picinfo.txt is saved to the current folder. It's a simple text file, so once created, you can edit it outside ThumbHTML if you wish. Here is an example ..

Back to the main page
© Jeff Waldock


ThumbHTML - Colours

ThumbHTML v2.7 - COLOURS
Colours

It is possible to customise the colours used by the program for various page elements by using the colour picker provided.
Select the palette required from the option button list, click on the element whose colour you wish to change, and choose the colour from the colour picker which pops up. You can cancel by pressing the Esc key, or by using the button labelled 'Ccl' (Cancel).

Colour Picker screenshot

It is also possible to specify the values of the LINK (hyperlink colour), ALINK (active link colour), VLINK (visited link colour), photo data, the date and time, and the footer text.
This can also be done manually, by editing the relevant profiles file, which can be found in the 'profiles' sub-folder of the ThumbHTML program directory.

The relevant entries are ...

BGHex=#003366
FGHex=#FFFFFF
LinkColorHex=#0099FF
AlinkColorHex=#0066FF
VlinkColorHex=#FFCC99
ImgTextHex=#33FF33
DateTextHex=#FFFF00
FooterTextHex=#FFFFFF
PhotoDataTextHex=#C0C0C0
The values are in HEX in the form "BBGGRR" with the amounts of blue, green and red specified between 00 and FF. If you edit this file, you need to restart the program to load the new colour values.

Be careful not to edit any other values!

NEW in version 2.4 is the ability to choose a background IMAGE, rather than a colour. Just check the box and you'll be able to select the image file you want to use (a preview will appear in the box shown in place of the background colour). This image will be used for ALL html pages generated by the program while the checkbox is checked. The image file chosen will be copied to the picture folder when the "Make HTML" button is clicked.

Back to the main page
© Jeff Waldock


ThumbHTML - Styles

ThumbHTML v2.7 - STYLE SHEETS
STYLE SHEETS

Version 2.7 of ThumbHTML introduces stylesheets - this should greatly enhance the possibilities for individual customisation of the HTML photo albums. A single stylesheet 'photos.css' is added to the root folder by the program. If the checkbox 'User-defined stylesheet' on the Style tab is unchecked then ThumbHTML will generate this stylesheet from the user-chosen colours on that tab. If the checkbox is checked, however, the user can choose to create, edit and use a custom stylesheet. At the moment, no specific help is provided with this, except for the comments provided in the default stylesheet provided.
Users cannot edit this default stylesheet, but it is possible to create a new one (ThumbHTML makes a copy of the default stylesheet) and then to edit that. Stylesheets allow all aspects of the appearance of each part of the HTML pages to be customised.

Here is a list of the stylesheet elements and the parts of the web pages to which they apply:

BODY | Defines background color, default foreground color and font size
A:LINK | Basic hyperlink properties
A:VISITED | 'visited' hyperlinks
A:HOVER | 'mouseover' link properties
DIV.footer | Default characteristics of footer text
H1 | Main title
.photodatetime | Characteristics of the photo date/time text
.caption | Picture comments/caption
A.footer, A:VISITED.footer | Characteristics of hyperlinks and visited links in the footer
A:HOVER.footer | Characteristics of 'mouseover' links in the footer
TD.alsoavailable | Text in the 'alsoavailable' section of individual HTML pages
A.alsoavailable, A:HOVER.alsoavailable, A:VISITED.alsoavailable | Links in the 'alsoavailable' section of individual HTML pages
#descriptions | Image comments in the slideshow
#photodetails | Picture data in the slideshow
#photodate | Image date/time in the slideshow
#filename | Image filename in the slideshow
#imagecount | Image number in the slideshow

This is the default stylesheet - default.css:

BODY {
background-color: #006699;
color: #FFFFFF;
font-family: Verdana, Geneva, Arial, Helvetica, Sans-Serif;
font-size: 12px;
}

/* links */
A:LINK {
font-family: Verdana, Geneva, Arial, Helvetica, Sans-Serif;
font-size: 12px;
color:#0099FF;
font-weight : normal;
text-decoration : none;
}

/* visited links */
A:VISITED {
font-family: Verdana, Geneva, Arial, Helvetica, Sans-Serif;
font-size: 12px;
color: #FFCC99;
font-weight : normal;
text-decoration : none;
}

/* mouse-over links */
A:HOVER {
font-family: Verdana, Geneva, Arial, Helvetica, Sans-Serif;
font-size: 12px;
color: #0099FF;
font-weight : normal;
text-decoration: underline;
}

/* footer text */
DIV.footer {
color: #FFFFFF;
font-size: 10px;
}

/* main title */
H1 {
font-family: Verdana, Geneva, Arial, Helvetica, Sans-Serif;
font-weight : Normal;
color: #FFFFFF;
font-size: 20px;
}

/* not currently used - has been replaced by <center> tags */
.mainbody {
 text-align: center;
}

/* date and time */
.photodatetime {
color: #FFFF00;
font-size: 10px;
}

/* photo data section */
.photodata {
color: #C0C0C0;
font-size: 10px;
text-align: right;
}

/* picture comments */
.caption {
color: #33FF33;
font-size: 12px;
text-align: center;
}

/* link colors in the footer section */
A.footer, A:VISITED.footer {
font-size: 10px;
}

/* mouseover-color of hyperlinks in the footer section */
A:HOVER.footer {
font-size: 10px;
color: #0099FF;
}

TD {
color: #33FF33;
font-family: Verdana, Geneva, Arial, Helvetica, Sans-Serif;
font-size: 12px;
}

/* text in the 'also-available' section of linked-image HTML pages */
TD.alsoavailable {
color: #33FF33;
font-size: 10px;
}

/* Hyperlinks in 'also-available' section of individual linked-image HTML pages */
A.alsoavailable,A:HOVER.alsoavailable,A:VISITED.alsoavailable {
font-size: 10px;
}

/* image descriptions in slideshow */
#descriptions {
color: #33FF33;
font-size: 12px;
text-align: center;
font-style: italic;
}

/* picture information in slideshow */
#photodetails {
color: #C0C0C0;
font-size: 11px;
text-align: right;
}

/* photo date and time in slideshow */
#photodate {
color: #FFFF00;
font-size: 11px;
}

/* image filename in slideshow */
#filename {
color: #C0C0C0;
font-size: 12px;
text-align: left;
}

/* image count in slideshow */
#imagecount {
font-size: 12px;
text-align: left;
}

Back to the main page
© Jeff Waldock


ThumbHTML - Picture Info

ThumbHTML v2.7 - Picture Information
Storing and Displaying Picture Information

Image information can be displayed on the linked pages if it is available. All Nikon digital cameras can be configured to save this picture informatgion into a file called info.txt, which can be downloaded along with the images to your hard disk. ThumbHTML will automatically use this file if it exists in the image directory. The data extracted and displayed in the linked HTML files consist of:

  • The date and time the picture was taken.
    N.B. This information can optionally be taken from the image file date-stamp, instead of from the info.txt file or the EXIF data - use the checkbox on the HTML tab to do this
  • The image dimensions
  • The image quality setting
  • The shutter speed
  • The aperture
The data file (info.txt) consists of a number of blocks of data, one for each image, like the following:
DSCN2209.JPG
CAMERA       : E995V1.6
METERING     : MATRIX
MODE         : P
SHUTTER      : 1/227sec
APERTURE     : F5.3
EXP +/-      : 0.0
FOCAL LENGTH : f8.2mm(X1.0)
IMG ADJUST   : AUTO
SENSITIVITY  : AUTO
WHITEBAL     : AUTO
SHARPNESS    : AUTO
DATE         : 04.05.2002 10:45
QUALITY      : UXGA NORMAL
SATURATION   : 0
FOCUS AREA   : CENTER
If you are not using a Nikon camera, or you did not save the picture information in info.txt, ThumbHTML will try to extract the necessary information from the EXIF header information stored in the image (if it is in JPG format).
ThumbHTML will extract a selection of the most useful data elements if available (editing and saving JPG files often destroys this information). You can choose which items to add to your HTML pages by selecting the EXIF item from the Tools menu. This brings up the following dialog ... As you can see, the most common elements are already included.

The 'Tools' menu contains an option to 'Export Picture Data'. If you choose this, the picture information will be saved to a file in the current root folder, called 'picturedata.txt' [Example].

More information about the Exif file format.

NB: if you have edited the images since transferring them from your digital camera, some or all of the EXIF data may be lost - if this is the case, ThumbHTML will simply not print it to the HTML page.

Back to the main page
© Jeff Waldock


ThumbHTML - Sorting

ThumbHTML v2.7 - Sorting
Sorting the Images

Using this facility you can now choose the order in which the images appear in your web pages. The default is to use the 'normal' order in which the images are sorted by Windows Explorer - alphabetically by filename. If you select the 'Sort' button, a dialog similar to the following will appear:

You will find thumbnails of all your selected images listed in the current order. The dialog will display 6 rows of 5 images - if you have more than 30 selected in the current folder, you can use the scrollbar to view the rest. A large number is placed over each image to indicate the current position of each image in the sort order.
To change the position of a particular image, simply drag and drop it to the desired position. (Note that you can only do this when you have the 'hand' cursor visible - this disappears when you position the mouse over the yellow number). Once you are satisfied that the order is correct, click the 'OK' menu item. If you wish to cancel any changes you have made (BEFORE clicking OK) use the 'Cancel' menu item.
If you want to undo any changes to the sort order AFTER clicking OK, the only way to do this is to change folder then change back - the original (alphabetical) sort order is then restored. At the moment, there is no way for the program to 'remember' your custom sort order - every time you open this folder you will have to re-sort them.

Back to the main page
© Jeff Waldock


ThumbHTML - Custom Headers and Footers

ThumbHTML v2.7 - Custom Footers
Custom Footers

ThumbHTML allows you to add your own customised footer - and a future release will allow you to customise the header as well. This may be easily achieved by either editing the file 'userfooter.txt', found in the ThumbHTML program directory, or to use the built-in editor provided by ThumbHTML - it's available via the 'Tools' menu. This will bring up the editor:

As you will see, I've taken the liberty of putting my own information there as the default!
New in v2.6 are various tools to help with creating the footer HTML. On the menu, these are:

Edit | Contains one sub-menu: Undo. This allows you to undo previous edits (up to 20).
Insert | (All dates and times will be current)
Format | Choosing 'Font' will bring up another dialog that provides a means of choosing font face, size and colour.

Back to the main page
© Jeff Waldock


ThumbHTML - Making HTML pages

ThumbHTML v2.7 - Making your web pages
Making your web pages

Once you have created all the re-sized images, customised to your requirements, the final step is to get ThumbHTML to generate the web pages for your photo album. You can accept all the defaults - the only thing you really ought to add is the title - and click on the 'Make HTML' button.
This will generate a number of web pages:

Firstly, there will be a set of thumbnail pages (the number will depend on how many images you have compared to the number of thumbnails you have asked for on each page, default 20). The first one will be index.html (or .htm if you chose that option), and the others will be thumb1.html, thumb2.html etc.

Secondly, there will be a page for each image (called, for example, DSCN0123.html, where DSCN0123.jpg is the image filename). These are the pages containing the individual images, together with any extra information you asked for, such as the filename, the photo details, the date taken etc. If you asked for the navigation buttons to be added, these pages will be linked to each other by them.

As you can see from the screenshot, there are a number of additional options, which should be self-explanatory.

Back to the main page
© Jeff Waldock


ThumbHTML - Slideshow

ThumbHTML v2.7 - Slideshow
Creating a Slideshow

You can create a slideshow with ThumbHTML, using the tab with that name. The program will by default use images in a sub-folder called 'main' - this is the folder normally used to store the linked images. Images in this folder need to be small enough the display comfortably without scrolling on a typical browser window (I use 600 pixels). You can select the folder desired, in any case, by using the drop-down list - this will contain all sub-folder names currently existing in the present folder.

As you can see, you can also choose the interval between images, the transition time, the title, the desired filename (it will be placed in the current folder) and whether or not to include a link to the HTML pages (this option will be disabled in a file index.html does not exist in this folder).

New in version 2.2 is the ability to display extra image information (e.g. date, photo data, comments etc). This information changes with the image, of course!

Note that the page preloads all images and image data, so don't create slideshows of too many images or it will take forever to load!

Back to the main page
© Jeff Waldock


Digital Photos

Image 13 (DSCN0889.JPG)
28/10/2001 at 13:03 2048x1536, Normal, f7.4, 1/303s
600x450 pixels (153.8K)
Copyright (c) 2001 Jeff Waldock
Bridlington
Back to the main page Also available:
1200 pixel (460.9K) | 900 pixel (298.0K) | Full size (646.8K)

Created with ThumbHTML v2.7
© Jeff Waldock, 2002


ThumbHTML - Profiles

ThumbHTML v2.7 - Profiles
Profiles

If you have several 'sets' of commonly-used settings, you can now save these as 'profiles', recalling them as needed. All settings are saved in a profiles file, stored in the profiles sub-folder of the ThumbHTML folder - a copy of the default settings file is given below.

Profiles are managed using the relevant menu items -= you can add and remove profiles easily. New profiles are created using the default settings below.
ThumbHTML.ini, which previously stored settings data, now just contains three settings: the last-used profile, and whether or not to save the existing profile details on exit, and load the last-used profile settings when re-starting.

[Thumb]
JPG=1
PNG=1
BMP=0
OverWrite=1
Progressive=0
Quality=95
DropShadow=1
ShadowBlur=75
ShadowOffset=5
ShadowAngle=135
ShadowColor=0
Border=0
BorderSize=1
BorderColor=0
ApplyGreyscale=0
ApplySharpening=0
Sharpening=10
ApplyTint=0
TintR=127
TintG=127
TintB=127
ThumbSize=150
RememberLastFolder=1
LastFolder=d:\Photos\2003\Jan19
MainFolderName=Main
ThumbFolderName=thumb
NoResize=0
SpecialFilter=0
SpecialFilterName=
UserStylesheet=1
StylesheetName=default
DisplayExifData=0

[WaterMark]
ApplyWatermark=1
WM_Defined=True
WM_Text=(c) Jeff Waldock, 2003
WM_Pos=2
WM_OffsetX=-10
WM_OffsetY=10
WM_FontName=Arial
WM_FontSize=10
WM_FontColor=0
WM_Transparency=20
WM_Smoothing=4

[HTML]
BGHex=#006699
FGHex=#FFFFFF
LinkColorHex=#0099FF
AlinkColorHex=#0099FF
VlinkColorHex=#FFCC99
ImgTextHex=#33FF33
DateTextHex=#FFFF00
FooterTextHex=#FFFFFF
PhotoDataTextHex=#C0C0C0
BackgroundImage=0
BackgroundImagePath=
DateFormat=0
DateFormatOther=
ImagesPerPage=20
Columns=5
Table=1
FileExtension=0
IncImageNumber=0
IncImageFilename=0
IncNavButtons=1
IncLinkToOriginal=1
IncCommentsWithThumbs=0
LookForExif=1
UseFileDateTime=0
LinkedImageNewWindow=1

[Slideshow]
SS_Interval=5
SS_TransitionTime=3
SS_Filename=slideshow
SS_IncFilenames=1
SS_IncDateTime=1
SS_IncComments=1
SS_IncPhotoDetails=1
SS_IncImageCount=1

[Batch]
thumb,150
main,600

[Footer]
<p><hr size=1>
<font size=1 color=white>
Created with <a href="http://landscapeimage.com/photos/downloads/ThumbHTML/">ThumbHTML v2.7</a>
<br> © Jeff Waldock, 2003
</font>
</body>

Back to the main page
© Jeff Waldock


Exif file format

Japanese document

Description of Exif file format

Currently, most of new digicam use Exif file format to store images. This specification was made by JEIDA, but there is no open document in internet. So I made tiny description about Exif from some of open documents that can get from internet.

Add: Now we can get official document of Exif2.1 from PIMA's website.

ISO is now working to build DCF (Design rule for Camera File system) Specification. The entire digicam manufacturer is moving to adopt it and their newest digicam already uses DCF. DCF defines whole file-system of digicam; directory structure, file naming method, character set and file format etc. The file format of DCF is based on Exif2.1 specification.

I believe this document is basically based on Exif2.1/DCF specification, if you have information about 'unknown' item or find errata, please e-mail me, TsuruZoh Tachibanaya , t s u r u z o h @ b a . w a k w a k . c o m

This is a FREE document, you may use this document for any purpose (commercial/non-commercial) of all/part of this document. All trade names mentioned in this document are trademarks or registered trademarks of their respective holders.

TsuruZoh Tachibanaya, t s u r u z o h @ b a . w a k w a k . c o m

http://www.ba.wakwak.com/~tsuruzoh/

rev. 1.4 Feb.03,2001
rev. 1.3 Sep.09,2000
rev. 1.2 Jul.19,2000
rev. 1.1 Dec.19,1999
rev. 1.0 May.28,1999

Referenced materials

Exif file format written by itojun (Japanese language document)
Exif file format written by Mamoru Ohno (Japanese language document)
TIFF6.0 Specification written by Adobe
TIFF/EP Specification written by ISO TC42 WG18
exifdump program written by Thierry Boush
DCF Specification written by ISO TC42 WG18
Exif2.1 Specification written by JEIDA

  • What is Exif format?
  • JPEG format and Marker
  • Marker used by Exif
  • Exif data structure
    • TIFF Header
    • IFD : Image file directory
    • Data format
    • IFD data structure
    • Thumbnail image
      • JPEG format thumnail
      • TIFF format thumbnail
  • Tag number used by Exif/TIFF
    • IFD0 (IFD of main image) section
    • Exif SubIFD section
    • IFD1 (IFD of thumbnail image) section
    • Misc Tags
  • Appendix 1: MakerNote of Olympus digicams
  • Appendix 2: MakerNote of Nikon digicams
  • Appendix 3: MakerNote of Casio digicams
  • Appendix 4: MakerNote of Fujifilm digicams
  • Appendix 5: MakerNote of Canon digicams
  • History
  • Acknowledgement

What is Exif file format?

Basically, Exif file format is the same as JPEG file format. Exif inserts some of image/digicam information data and thumbnail image to JPEG in conformity to JPEG specification. Therefore you can view Exif format image files by JPEG compliant Internet browser/Picture viewer/Photo retouch software etc. as a usual JPEG image files.

JPEG format and Marker

Every JPEG file starts from binary value '0xFFD8', ends by binary value '0xFFD9'. There are several binary 0xFFXX data in JPEG data, they are called as "Marker", and it means the period of JPEG information data. 0xFFD8 means SOI(Start of image), 0xFFD9 means EOI(End of image). These two special Markers have no data following, the other Markers have data with it. Basic format of Marker is below.

0xFF+Marker Number(1 byte)+Data size(2 bytes)+Data(n bytes)

Data size(2 Bytes) has "Motorola" byte align, starts from bigger digits. Please notice that "Data" contains Data size descriptor, if there is a Marker like this;

FF C1 00 0C

It means this Marker(0xFFC1) has 0x000C(equal 12)bytes of data. But the data size '12' includes "Data size" descriptor, it follows only 10 bytes of data after 0x000C.

In JPEG format, some of Markers describe data, then SOS(Start of stream) Marker placed. After the SOS marker, JPEG image stream starts and terminated by EOI Marker.

SOI Marker | Marker XX size=SSSS |  |  | Marker YY size=TTTT |  |  | SOS Marker size=UUUU |  |  | Image stream | EOI Marker
FFD8 | FFXX | SSSS | DDDD...... | FFYY | TTTT | DDDD...... | FFDA | UUUU | DDDD.... | I I I I.... | FFD9

Marker used by Exif

The marker 0xFFE0~0xFFEF is named "Application Marker", not necessary for decoding JPEG image. They are used by user application. For example, older olympus/canon/casio/agfa digicam use JFIF(JPEG File Interchange Format) for storing images. JFIF uses APP0(0xFFE0) Marker for inserting digicam configuration data and thumbnail image.

Also Exif uses an Application Marker for inserting data, but Exif uses APP1(0xFFE1) Marker to avoid a conflict with JFIF format. Every Exif file formats starts from this format;

SOI Marker | APP1 Marker | APP1 Data | Other Marker
FFD8 | FFE1 | SSSS 457869660000 TTTT...... | FFXX SSSS DDDD......

It starts from SOI(0xFFD8) Marker, so it's a JPEG file. Then APP1 Marker follows immediately. All the data of Exif are stored in this APP1 data area. The part of "SSSS" on upper table means the size of APP1 data area (Exif data area). Please notice that the size "SSSS" includes the size of descriptor itself also.

After the "SSSS", APP1 data starts. The first part is a special data to identify whether Exif or not, ASCII character "Exif" and 2bytes of 0x00 are used.

After the APP1 Marker area, the other JPEG Markers follows.

Exif data structure

Roughly structure of Exif data (APP1) is shown as below. This is a case of "Intel" byte aligns and it contains JPEG format thumbnail. As described above, Exif data is starts from ASCII character "Exif" and 2bytes of 0x00, and then Exif data follows. Exif uses TIFF format to store data. For more details of TIFF format, please refer to "TIFF6.0 specification".

FFE1 | APP1 Marker
SSSS | APP1 Data | APP1 Data Size
45786966 0000 |  | Exif Header
49492A00 08000000 |  | TIFF Header
XXXX. . . . |  | IFD0 (main image) |  |  | Directory
LLLLLLLL |  |  |  |  | Link to IFD1
XXXX. . . . |  | Data area of IFD0
XXXX. . . . |  |  | Exif SubIFD |  | Directory
00000000 |  |  |  |  | End of Link
XXXX. . . . |  |  | Data area of Exif SubIFD
XXXX. . . . |  |  |  | Interoperability IFD | Directory
00000000 |  |  |  |  | End of Link
XXXX. . . . |  |  |  | Data area of Interoperability IFD
XXXX. . . . |  |  |  | Makernote IFD | Directory
00000000 |  |  |  |  | End of Link
XXXX. . . . |  |  |  | Data area of Makernote IFD
XXXX. . . . |  | IFD1(thumbnail image) |  |  | Directory
00000000 |  |  |  |  | End of Link
XXXX. . . . |  | Data area of IFD1
FFD8XXXX. . . XXXXFFD9 |  | Thumbnail image

Structure of TIFF header

First 8bytes of TIFF format are TIFF header. First 2bytes defines byte align of TIFF data. If it is 0x4949="I I", it means "Intel" type byte align. If it is 0x4d4d="MM", it means "Motorola" type byte align. For example, value '305,419,896' is noted as 0x12345678 by sixteenth system. At the Motorola align, it is stored as 0x12,0x34,0x56,0x78. If it's Intel align, it is stored as 0x78,0x56,0x34,0x12. It seems that most of digicam uses Intel align. Ricoh uses Motorola align. Sony uses Intel align except D700. Kodak DC200/210/240 use Motorola aligns, but DC220/260 use Intel aligns though they are using PowerPC! Therefore when we need the value of Exif data, we MUST check byte align every time. Though JPEG data uses Motorola align only, Exif allows both alignments. I can't understand why Exif didn't fix a byte align to Motorola.

Next 2bytes are always 2bytes-length value of 0x002A. If the data uses Intel align, next 2bytes are "0x2a,0x00". If it uses Motorola, they are "0x00,0x2a". The last 4bytes of TIFF header are an offset to the first IFD(Image File Directory, described in next chapter). Includes this offset, all the offset value used in TIFF format counts offset bytes from the first of TIFF header("I I" or "MM"). Usually the first IFD starts immediately next to TIFF header, so this offset has value '0x00000008'.

Byte align | TAG Mark | Offset to first IFD
"I I" or "MM" | 0x002a | 0x00000008

IFD : Image file directory

Next to TIFF header, there is the first IFD:Image File Directory. It contains image information data. At the chart below, the first 2bytes('EEEE') means the number of directory entry contains in this IFD. Then directory entry (12bytes per entry) follows. After last directory entry, there is a 4bytes of data('LLLLLLLL' at the chart), it means an offset to next IFD. If its value is '0x00000000', it means this is the last IFD and there is no linked IFD.

EEEE |  |  |  | No. of directory entry
TTTT | ffff | NNNNNNNN | DDDDDDDD | Entry 0
TTTT | ffff | NNNNNNNN | DDDDDDDD | Entry 1
. . . . . . . . . |  |  |  | . . . . . .
TTTT | ffff | NNNNNNNN | DDDDDDDD | Entry EEEE-1
LLLLLLLL |  |  |  | Offset to next IFD

'TTTT'(2bytes) of above chart is Tag number, this shows a kind of data. 'ffff'(2bytes) is data format, 'NNNNNNNN'(4bytes) is number of components. 'DDDDDDDD'(4bytes) contains a data value or offset to data value.

Data format

Data format ('ffff' at the above chart) is defined as below. "rational" means a fractional value, it contains 2-signed/unsigned long integer values, and the first represents the numerator, and the second, the denominator.
Value | 1 | 2 | 3 | 4 | 5 | 6
Format | unsigned byte | ascii strings | unsigned short | unsigned long | unsigned rational | signed byte
Bytes/component | 1 | 1 | 2 | 4 | 8 | 1
Value | 7 | 8 | 9 | 10 | 11 | 12
Format | undefined | signed short | signed long | signed rational | single float | double float
Bytes/component | 1 | 2 | 4 | 8 | 4 | 8

You can get the total data byte length by multiplies a 'bytes/components' value (see above chart) by number of components stored 'NNNNNNNN' area. If total data length is less than 4bytes, 'DDDDDDDD' contains the value of that Tag. If its size is over 4bytes, 'DDDDDDDD' contains the offset to data stored address.

IFD data structure

At Exif format, the first IFD is IFD0(IFD of main image), then it links to IFD1(IFD of thumbnail image) and IFD link is terminated. But IFD0/IFD1 doesn't contain any digicam's information such as shutter speed, focal length etc. IFD0 always contains special Tag Exif Offset (0x8769), it shows an offset to Exif SubIFD. Exif SubIFD is IFD formatted data also, it contains digicam's information.

In case of Extended Exif format (Exif2.1/DCF), Exif SubIFD contains special Tag Exif Interoperability Offset (0xa005). It also points to the Interoperability IFD. By the DCF specification, this tag is mandatory and both SubIFD (main image IFD) and IFD1 (thumbnail image IFD) may have Interoperability IFD. In usual, only main image have this tag.

And some of digicam uses IFD data format for Makernote; Maker-specific magic number area. It's very hard to decision whether makernote is IFD format or not, be careful to coding program. See Appendix for information of Makernote.
0000: 49 49 2A 00 08 00 00 00-02 00 1A 01 05 00 01 00
0010: 00 00 26 00 00 00 69 87-04 00 01 00 00 00 11 02
0020: 00 00 40 00 00 00 48 00-00 00 01 00 00 00
If the first part of TIFF data is above, it can read as;
  • The first 2bytes are "I I", byte align is 'Intel'.
  • Address 0x0004~0x0007 is 0x08000000, IFD0 starts from address '0x0008'
  • Address 0x0008~0x0009 is 0x0200, number of directory entry of IFD0 is '2'.
  • Address 0x000a~0x000b is 0x1A01, it means this is an XResolution(0x011A) Tag, it contains a horizontal resolution of image.
  • Address 0x000c~0x000d is 0x0500, format of this value is unsigned rational(0x0005).
  • Address 0x000e~0x0011 is 0x01000000, number of components is '1'. Unsigned rational's data size is 8bytes/components, so total data length is 1x8=8bytes.
  • Total data length is larger than 4bytes, so next 4bytes contains an offset to data.
  • Address 0x0012~0x0015 is 0x26000000, XResolution data is stored to address 0x0026
  • Address 0x0026~0x0029 is 0x48000000, numerator is 72, address 0x002a~0x002d is 0x0100000000, denominator is '1'. So the value of XResoultion is 72/1.
  • Address0x0016~0x0017 is 0x6987, next Tag is ExifOffset(0x8769). Its value is an offset to Exif SubIFD
  • Data format is 0x0004, unsigned long integer.
  • This Tag has one component. Unsigned long integer's data size is 4bytes/components, so total data size is 4bytes.
  • Total data size is equal to 4bytes, next 4bytes contains the value of Exif SubIFD offset.
  • Address 0x001e~0x0021 is 0x11020000, Exif SubIFD starts from address '0x0211'.
  • This is the last directory entry, next 4bytes shows an offset to next IFD.
  • Address 0x0022~0x0025 is 0x40000000, next IFD starts from address '0x0040'

Thumbnail image

Exif format contains thumbnail of image (except Ricoh RDC-300Z). Usually it is located next to the IFD1. There are 3 formats for thumbnails; JPEG format(JPEG uses YCbCr), RGB TIFF format, YCbCr TIFF format. It seems that JPEG format and 160x120 pixels of size are recommended thumbnail format for Exif2.1 or later. By the DCF specification, thumbnail image MUST use JPEG format and image size is fixed to 160x120 pixels.

JPEG format thumbnail

If the value of Compression(0x0103) Tag in IFD1 is '6', thumbnail image format is JPEG. Most of Exif image uses JPEG format for thumbnail. In that case, you can get offset of thumbnail from JpegIFOffset(0x0201) Tag in IFD1, size of thumbnail from JpegIFByteCount(0x0202) Tag. Data format is ordinary JPEG format, starts from 0xFFD8 and ends by 0xFFD9.

TIFF format thumbnail

If the value of Compression(0x0103) Tag in IFD1 is '1', thumbnail image format is no compression(called TIFF image). Start point of thumbnail data is StripOffset(0x0111) Tag, size of thumbnail is the sum of StripByteCounts(0x0117) Tag.

If thumbnail uses no compression and PhotometricInterpretation(0x0106)Tag in IFD1 has a value '2', thumbnail uses RGB format. In that case, you can see thumbnail image by simply copy data to computer's RGB format(such as BMP format, or copy to VRAM directory). Kodak DC-210/220/260 uses this format. Be mention that at TIFF stores pixel data as 'RGB' order, but BMP stores 'BGR' order.
If that tag has a value '6', thumbnail uses YCbCr format. If you want to see thumbnail, you must convert it to RGB. Ricoh RDC4200/4300, Fuji DS-7/300 and DX-5/7/9 use this format(newer RDC5000/MX-X00 series use JPEG). Next section is brief description to conversion of Fuji DS's thumbnail. For more details, refer to TIFF6.0 specification.

At DX-5/7/9, YCbCrSubsampling(0x0212) has values of '2,1', PlanarConfiguration(0x011c) has a value '1'. So the data align of this image is below.

Y(0,0),Y(1,0),Cb(0,0),Cr(0,0), Y(2,0),Y(3,0),Cb(2,0),Cr(3.0), Y(4,0),Y(5,0),Cb(4,0),Cr(4,0). . . .

The numeric in parenthesis is pixel coordinates. DX series' YCbCrCoefficients(0x0211) has values '0.299/0.587/0.114', ReferenceBlackWhite(0x0214) has values '0,255,128,255,128,255'. Therefore to convert from Y/Cb/Cr to RGB is;

B(0,0)=(Cb-128)*(2-0.114*2)+Y(0,0)
R(0,0)=(Cr-128)*(2-0.299*2)+Y(0,0)
G(0,0)=(Y(0,0)-0.114*B(0,0)-0.299*R(0,0))/0.587

Horizontal subsampling is a value '2', so you can calculate B(1,0)/R(1,0)/G(1,0) by using the Y(1,0) and Cr(0,0)/Cb(0,0). Repeat this conversion by value of ImageWidth(0x0100) and ImageLength(0x0101).

Tag number used by Exif/TIFF

Tag numbers used by Exif/TIFF are shown as below. If the Tag has upper limit of components number, CompoNo column has numeric value. If it has no value, there is no limitation.
Tags used by IFD0 (main image)
Tag No. | Tag Name | Format | CompoNo | Desc.
0x010e ImageDescription ascii string
Describes image. Two-byte character code such as Chinese/Korean/Japanese cannot be used.
0x010f Make ascii string
Shows manufacturer of digicam. In the Exif standard, this tag is optional, but it is mandatory for DCF.
0x0110 Model ascii string
Shows model number of digicam. In the Exif standard, this tag is optional, but it is mandatory for DCF.
0x0112 Orientation unsigned short 1
Value | 0th Row | 0th Column
1 | top | left side
2 | top | right side
3 | bottom | right side
4 | bottom | left side
5 | left side | top
6 | right side | top
7 | right side | bottom
8 | left side | bottom
The orientation of the camera relative to the scene, when the image was captured. The relation of the '0th row' and '0th column' to visual position is shown as right.
0x011a | XResolution | unsigned rational | 1 | Display/Print resolution of image. Default value is 1/72inch, but it has no mean because personal computer doesn't use this value to display/print out.
0x011b | YResolution | unsigned rational | 1
0x0128 | ResolutionUnit | unsigned short | 1 | Unit of XResolution(0x011a)/YResolution(0x011b). '1' means no-unit, '2' means inch, '3' means centimeter. Default value is '2'(inch).
0x0131 Software ascii string
Shows firmware(internal software of digicam) version number.
0x0132 | DateTime | ascii string | 20 | Date/Time of image was last modified. Data format is "YYYY:MM:DD HH:MM:SS"+0x00, total 20bytes. If clock has not set or digicam doesn't have clock, the field may be filled with spaces. In usual, it has the same value of DateTimeOriginal(0x9003)
0x013e | WhitePoint | unsigned rational | 2 | Defines chromaticity of white point of the image. If the image uses CIE Standard Illumination D65(known as international standard of 'daylight'), the values are '3127/10000,3290/10000'.
0x013f | PrimaryChromaticities | unsigned rational | 6 | Defines chromaticity of the primaries of the image. If the image uses CCIR Recommendation 709 primaries, values are '640/1000,330/1000,300/1000,600/1000,150/1000,0/1000'.
0x0211 | YCbCrCoefficients | unsigned rational | 3 | When image format is YCbCr, this value shows a constant to translate it to RGB format. In usual, values are '0.299/0.587/0.114'.
0x0213 | YCbCrPositioning | unsigned short | 1 | When image format is YCbCr and uses 'Subsampling'(cropping of chroma data, all the digicam do that), defines the chroma sample point of subsampling pixel array. '1' means the center of pixel array, '2' means the datum point.
0x0214 | ReferenceBlackWhite | unsigned rational | 6 | Shows reference value of black point/white point. In case of YCbCr format, first 2 show black/white of Y, next 2 are Cb, last 2 are Cr. In case of RGB format, first 2 show black/white of R, next 2 are G, last 2 are B.
0x8298 Copyright ascii string
Shows copyright information
0x8769 | ExifOffset | unsigned long | 1 | Offset to Exif Sub IFD

Tags used by Exif SubIFD
Tag No. | Tag Name | Format | CompoNo | Desc.
0x829a | ExposureTime | unsigned rational | 1 | Exposure time (reciprocal of shutter speed). Unit is second.
0x829d | FNumber | unsigned rational | 1 | The actual F-number(F-stop) of lens when the image was taken.
0x8822 | ExposureProgram | unsigned short | 1 | Exposure program that the camera used when image was taken. '1' means manual control, '2' program normal, '3' aperture priority, '4' shutter priority, '5' program creative (slow program), '6' program action(high-speed program), '7' portrait mode, '8' landscape mode.
0x8827 | ISOSpeedRatings | unsigned short | 2 | CCD sensitivity equivalent to Ag-Hr film speedrate.
0x9000 | ExifVersion | undefined | 4 | Exif version number. Stored as 4bytes of ASCII character. If the picture is based on Exif V2.1, value is "0210". Since the type is 'undefined', there is no NULL(0x00) for termination.
0x9003 | DateTimeOriginal | ascii string | 20 | Date/Time of original image taken. This value should not be modified by user program. Data format is "YYYY:MM:DD HH:MM:SS"+0x00, total 20bytes. If clock has not set or digicam doesn't have clock, the field may be filled with spaces. In the Exif standard, this tag is optional, but it is mandatory for DCF.
0x9004 | DateTimeDigitized | ascii string | 20 | Date/Time of image digitized. Usually, it contains the same value of DateTimeOriginal(0x9003). Data format is "YYYY:MM:DD HH:MM:SS"+0x00, total 20bytes. If clock has not set or digicam doesn't have clock, the field may be filled with spaces. In the Exif standard, this tag is optional, but it is mandatory for DCF.
0x9101 ComponentsConfiguration undefined
Shows the order of pixel data. Most of case '0x04,0x05,0x06,0x00' is used for RGB-format and '0x01,0x02,0x03,0x00' for YCbCr-format. 0x00:does not exist, 0x01:Y, 0x02:Cb, 0x03:Cr, 0x04:Red, 0x05:Green, 0x06:Bllue.
0x9102 | CompressedBitsPerPixel | unsigned rational | 1 | The average compression ratio of JPEG (rough estimate).
0x9201 | ShutterSpeedValue | signed rational | 1 | Shutter speed by APEX value. To convert this value to ordinary 'Shutter Speed'; calculate this value's power of 2, then reciprocal. For example, if the ShutterSpeedValue is '4', shutter speed is 1/(24)=1/16 second.
0x9202 | ApertureValue | unsigned rational | 1 | The actual aperture value of lens when the image was taken. Unit is APEX. To convert this value to ordinary F-number(F-stop), calculate this value's power of root 2 (=1.4142). For example, if the ApertureValue is '5', F-number is 1.41425 = F5.6.
0x9203 BrightnessValue signed rational 1 Brightness of taken subject, unit is APEX. To calculate Exposure(Ev) from BrigtnessValue(Bv), you must add SensitivityValue(Sv).
Ev=Bv+Sv Sv=log2(ISOSpeedRating/3.125)
ISO100:Sv=5, ISO200:Sv=6, ISO400:Sv=7, ISO125:Sv=5.32.
0x9204 | ExposureBiasValue | signed rational | 1 | Exposure bias(compensation) value of taking picture. Unit is APEX(EV).
0x9205 | MaxApertureValue | unsigned rational | 1 | Maximum aperture value of lens. You can convert to F-number by calculating power of root 2 (same process of ApertureValue:0x9202).
0x9206 | SubjectDistance | signed rational | 1 | Distance to focus point, unit is meter.
0x9207 | MeteringMode | unsigned short | 1 | Exposure metering method. '0' means unknown, '1' average, '2' center weighted average, '3' spot, '4' multi-spot, '5' multi-segment, '6' partial, '255' other.
0x9208 | LightSource | unsigned short | 1 | Light source, actually this means white balance setting. '0' means unknown, '1' daylight, '2' fluorescent, '3' tungsten, '10' flash, '17' standard light A, '18' standard light B, '19' standard light C, '20' D55, '21' D65, '22' D75, '255' other.
0x9209 | Flash | unsigned short | 1 | '0' means flash did not fire, '1' flash fired, '5' flash fired but strobe return light not detected, '7' flash fired and strobe return light detected.
0x920a | FocalLength | unsigned rational | 1 | Focal length of lens used to take image. Unit is millimeter.
0x927c MakerNote undefined
Maker dependent internal data. Some of maker such as Olympus/Nikon/Sanyo etc. uses IFD format for this area.
0x9286 UserComment undefined
Stores user comment. This tag allows to use two-byte character code or unicode. First 8 bytes describe the character code. 'JIS' is a Japanese character code (known as Kanji).
'0x41,0x53,0x43,0x49,0x49,0x00,0x00,0x00':ASCII
'0x4a,0x49,0x53,0x00,0x00,0x00,0x00,0x00':JIS
'0x55,0x4e,0x49,0x43,0x4f,0x44,0x45,0x00':Unicode
'0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00':Undefined
0x9290 SubsecTime ascii string
Some of digicam can take 2~30 pictures per second, but DateTime/DateTimeOriginal/DateTimeDigitized tag can't record the sub-second time. SubsecTime tag is used to record it.
For example, DateTimeOriginal = "1996:09:01 09:15:30", SubSecTimeOriginal = "130", Combined original time is "1996:09:01 09:15:30.130"
0x9291 SubsecTimeOriginal ascii string
0x9292 SubsecTimeDigitized ascii string
0xa000 | FlashPixVersion | undefined | 4 | Stores FlashPix version. If the image data is based on FlashPix formar Ver.1.0, value is "0100". Since the type is 'undefined', there is no NULL(0x00) for termination.
0xa001 | ColorSpace | unsigned short | 1 | Defines Color Space. DCF image must use sRGB color space so value is always '1'. If the picture uses the other color space, value is '65535':Uncalibrated.
0xa002 | ExifImageWidth | unsigned short/long | 1 | Size of main image.
0xa003 | ExifImageHeight | unsigned short/long | 1
0xa004 RelatedSoundFile ascii string
If this digicam can record audio data with image, shows name of audio data.
0xa005 | ExifInteroperabilityOffset | unsigned long | 1 | Extension of "ExifR98", detail is unknown. This value is offset to IFD format data. Currently there are 2 directory entries, first one is Tag0x0001, value is "R98", next is Tag0x0002, value is "0100".
0xa20e | FocalPlaneXResolution | unsigned rational | 1 | Pixel density at CCD's position. If you have MegaPixel digicam and take a picture by lower resolution(e.g.VGA mode), this value is re-sampled by picture resolution. In such case, FocalPlaneResolution is not same as CCD's actual resolution.
0xa20f | FocalPlaneYResolution | unsigned rational | 1
0xa210 FocalPlaneResolutionUnit unsigned short 1 Unit of FocalPlaneXResoluton/FocalPlaneYResolution. '1' means no-unit, '2' inch, '3' centimeter.

Note:Some of Fujifilm's digicam(e.g.FX2700,FX2900,Finepix4700Z/40i etc) uses value '3' so it must be 'centimeter', but it seems that they use a '8.3mm?'(1/3in.?) to their ResolutionUnit. Fuji's BUG? Finepix4900Z has been changed to use value '2' but it doesn't match to actual value also.
0xa215 | ExposureIndex | unsigned rational | 1 | Same as ISOSpeedRatings(0x8827) but data type is unsigned rational. Only Kodak's digicam uses this tag instead of ISOSpeedRating, I don't know why(historical reason?).
0xa217 | SensingMethod | unsigned short | 1 | Shows type of image sensor unit. '2' means 1 chip color area sensor, most of all digicam use this type.
0xa300 | FileSource | undefined | 1 | Indicates the image source. Value '0x03' means the image source is digital still camera.
0xa301 | SceneType | undefined | 1 | Indicates the type of scene. Value '0x01' means that the image was directly photographed.
0xa302 CFAPattern undefined
Indicates the Color filter array(CFA) geometric pattern.
Length | Type | Meaning
2 | short | Horizontal repeat pixel unit = n
2 | short | Vertical repeat pixel unit = m
1 | byte | CFA value[0,0]
: | : | :
1 | byte | CFA value[n-1,0]
1 | byte | CFA value[0,1]
: | : | :
1 | byte | CFA value[n-1,m-1]

The relation of filter color to CFA value is shown below.
Filter Color | Red | Green | Blue | Cyan | Magenta | Yellow | White
CFA value | 0 | 1 | 2 | 3 | 4 | 5 | 6

R | G
G | B
For example, ordinary RGB filter uses the repetition of left chart, the value is '0x0002,0x0002,0x00,0x01,0x01,0x02'.

Tags used by Interoperability IFD
Tag No. | Tag Name | Format | CompoNo | Desc.
0x0001 | InteroperabilityIndex | Ascii string | 4 | If this IFD is main image's IFD and the file content is equivalent to ExifR98 v1.0, the value is "R98". If thumbnail image's, value is "THM".
0x0002 | InteroperabilityVersion | Undefined | 4 | Records the interoperability version. "0100" means version 1.00.
0x1000 | RelatedImageFileFormat | Ascii string | any | Records the file format of image file. Value is ascii string (e.g. "Exif JPEG Ver. 2.1").
0x1001 | RelatedImageWidth | Short or Long | 1 | Records the image size.
0x1001 | RelatedImageLength | Short or Long | 1

Tags used by IFD1 (thumbnail image)
Tag No. | Tag Name | Format | CompoNo | Desc.
0x0100 | ImageWidth | unsigned short/long | 1 | Shows size of thumbnail image.
0x0101 | ImageLength | unsigned short/long | 1
0x0102 | BitsPerSample | unsigned short | 3 | When image format is no compression, this value shows the number of bits per component for each pixel. Usually this value is '8,8,8'
0x0103 | Compression | unsigned short | 1 | Shows compression method. '1' means no compression, '6' means JPEG compression.
0x0106 | PhotometricInterpretation | unsigned short | 1 | Shows the color space of the image data components. '1' means monochrome, '2' means RGB, '6' means YCbCr.
0x0111 | StripOffsets | unsigned short/long |  | When image format is no compression, this value shows offset to image data. In some case image data is striped and this value is plural.
0x0115 | SamplesPerPixel | unsigned short | 1 | When image format is no compression, this value shows the number of components stored for each pixel. At color image, this value is '3'.
0x0116 | RowsPerStrip | unsigned short/long | 1 | When image format is no compression and image has stored as strip, this value shows how many rows stored to each strip. If image has not striped, this value is the same as ImageLength(0x0101).
0x0117 | StripByteConunts | unsigned short/long |  | When image format is no compression and stored as strip, this value shows how many bytes used for each strip and this value is plural. If image has not stripped, this value is single and means whole data size of image.
0x011a | XResolution | unsigned rational | 1 | Display/Print resolution of image. Large number of digicam uses 1/72inch, but it has no mean because personal computer doesn't use this value to display/print out.
0x011b | YResolution | unsigned rational | 1
0x011c | PlanarConfiguration | unsigned short | 1 | When image format is no compression YCbCr, this value shows byte aligns of YCbCr data. If value is '1', Y/Cb/Cr value is chunky format, contiguous for each subsampling pixel. If value is '2', Y/Cb/Cr value is separated and stored to Y plane/Cb plane/Cr plane format.
0x0128 | ResolutionUnit | unsigned short | 1 | Unit of XResolution(0x011a)/YResolution(0x011b). '1' means inch, '2' means centimeter.
0x0201 | JpegIFOffset | unsigned long | 1 | When image format is JPEG, this value show offset to JPEG data stored.
0x0202 | JpegIFByteCount | unsigned long | 1 | When image format is JPEG, this value shows data size of JPEG image.
0x0211 | YCbCrCoefficients | unsigned rational | 3 | When image format is YCbCr, this value shows constants to translate it to RGB format. In usual, '0.299/0.587/0.114' are used.
0x0212 | YCbCrSubSampling | unsigned short | 2 | When image format is YCbCr and uses subsampling(cropping of chroma data, all the digicam do that), this value shows how many chroma data subsampled. First value shows horizontal, next value shows vertical subsample rate.
0x0213 | YCbCrPositioning | unsigned short | 1 | When image format is YCbCr and uses 'Subsampling'(cropping of chroma data, all the digicam do that), this value defines the chroma sample point of subsampled pixel array. '1' means the center of pixel array, '2' means the datum point(0,0).
0x0214 | ReferenceBlackWhite | unsigned rational | 6 | Shows reference value of black point/white point. In case of YCbCr format, first 2 show black/white of Y, next 2 are Cb, last 2 are Cr. In case of RGB format, first 2 show black/white of R, next 2 are G, last 2 are B.

Misc Tags
Tag No. | Tag Name | Format | CompoNo | Desc.
0x00fe | NewSubfileType | unsigned long | 1 |
0x00ff | SubfileType | unsigned short | 1 |
0x012d | TransferFunction | unsigned short | 3 |
0x013b | Artist | ascii string |  |
0x013d | Predictor | unsigned short | 1 |
0x0142 | TileWidth | unsigned short | 1 |
0x0143 | TileLength | unsigned short | 1 |
0x0144 | TileOffsets | unsigned long |  |
0x0145 | TileByteCounts | unsigned short |  |
0x014a | SubIFDs | unsigned long |  |
0x015b | JPEGTables | undefined |  |
0x828d | CFARepeatPatternDim | unsigned short | 2 |
0x828e | CFAPattern | unsigned byte |  |
0x828f | BatteryLevel | unsigned rational | 1 |
0x83bb | IPTC/NAA | unsigned long |  |
0x8773 | InterColorProfile | undefined |  |
0x8824 | SpectralSensitivity | ascii string |  |
0x8825 | GPSInfo | unsigned long | 1 |
0x8828 | OECF | undefined |  |
0x8829 | Interlace | unsigned short | 1 |
0x882a | TimeZoneOffset | signed short | 1 |
0x882b | SelfTimerMode | unsigned short | 1 |
0x920b | FlashEnergy | unsigned rational | 1 |
0x920c | SpatialFrequencyResponse | undefined |  |
0x920d | Noise | undefined |  |
0x9211 | ImageNumber | unsigned long | 1 |
0x9212 | SecurityClassification | ascii string | 1 |
0x9213 | ImageHistory | ascii string |  |
0x9214 | SubjectLocation | unsigned short | 4 |
0x9215 | ExposureIndex | unsigned rational | 1 |
0x9216 | TIFF/EPStandardID | unsigned byte | 4 |
0xa20b | FlashEnergy | unsigned rational | 1 |
0xa20c | SpatialFrequencyResponse | unsigned short | 1 |
0xa214 | SubjectLocation | unsigned short | 1 |

Appendix 1: MakerNote of Olympus Digicams

The data below is analyzed at Olympus D450Z(C-920Z) by Peter Esherick.

MakerNote of Olympus Digicam starts from ASCII string "OLYMP". Data format is the same as IFD, but it starts from offset 0x07. Example of actual data structure is shown below.
:0000: 4F 4C 59 4D 50 00 01 00-0B 00 00 02 04 00 03 00  OLYMP...........
:0010: 00 00 0E 04 00 00 01 02-03 00 01 00 00 00 03 00  ................

Tag No. | Tag Name | Format | CompoNo | Value
0x0200 | SpecialMode | Unsigned Long | 3 | Shows picture taking mode. First value means 0=normal, 1=unknown, 2=fast, 3=panorama. Second value means sequence number, third value means panorama direction, 1=left to right, 2=right to left, 3=bottom to top, 4=top to bottom.
0x0201 | JpegQual | Unsigned Short | 1 | Shows JPEG quality. 1=SQ,2=HQ,3=SHQ.
0x0202 | Macro | Unsigned Short | 1 | Shows Macro mode or not. 0=normal, 1=macro.
0x0203 | Unknown | Unsigned Short | 1 | Unknown
0x0204 | DigiZoom | Unsigned Rational | 1 | Shows Digital Zoom ratio. 0=normal, 2=digital 2x zoom.
0x0205 | Unknown | Unsigned Rational | 1 | Unknown
0x0206 | Unknown | Signed Short | 6 | Unknown
0x0207 | SoftwareRelease | Ascii string | 5 | Shows Firmware version.
0x0208 | PictInfo | Ascii string | 52 | Contains ASCII format data such as [PictureInfo]. This is the same data format of older Olympus digicam that not used Exif data format (C1400/C820/D620/D340 etc).
0x0209 | CameraID | Undefined | 32 | Contains CameraID data, which is user changeable by some utilities
0x0f00 | DataDump | Unsigned Long | 30 | Unknown

Appendix 2: MakerNote of Nikon

There are 2 formats of Nikon's MakerNote. MakerNote of E700/E800/E900/E900S/E910/E950 starts from ASCII string "Nikon". Data format is the same as IFD, but it starts from offset 0x08. This is the same as Olympus except start string. Example of actual data structure is shown below.
:0000: 4E 69 6B 6F 6E 00 01 00-05 00 02 00 02 00 06 00 Nikon...........
:0010: 00 00 EC 02 00 00 03 00-03 00 01 00 00 00 06 00 ................

Tag No. | Tag Name | Format | CompoNo | Value
0x0002 | Unknown | Ascii string | 6 | Unknown. E900/E900S/E910:"09.41", others:"08.00".
0x0003 | Quality | Unsigned short | 1 | Shows quality setting. At E900, 1:VGA Basic, 2:VGA Normal, 3:VGA Fine, 4:SXGA Basic, 5:SXGA Normal, 6:SXGA Fine
0x0004 | Color Mode | Unsigned short | 1 | 1:Color, 2:Monochrome.
0x0005 | Image Adjustment | Unsigned short | 1 | 0:Normal, 1:Bright+, 2:Bright-, 3:Contrast+, 4:Contrast-.
0x0006 | CCD Sensitivity | Unsigned short | 1 | 0:ISO80, 2:ISO160, 4:ISO320, 5:ISO100
0x0007 | White balance | Unsigned short | 1 | 0:Auto, 1:Preset, 2:Daylight, 3:Incandescense, 4:Fluorescence, 5:Cloudy, 6:SpeedLight
0x0008 | Focus | Unsigned rational | 1 | If infinite focus, value is '1/0'.
0x0009 | Unknown | Ascii string | 20 | Unknown
0x000a | Digital Zoom | Unsigned rational | 1 | '160/100' means 1.6x digital zoom, '0/100' means no digital zoom (optical zoom only).
0x000b | Converter | Unsigned short | 1 | If Fisheye Converter is used, value is '1'.
0x0f00 | Unknown | Unsigned long | 25~30 | Unknown

At E990, there is no Ascii string. As like the usual IFD (e.g. IFD0, SubIFD), IFD starts from the first byte of data. Nikon D1 also uses this format. Example of actual data structure is shown below.
:0000: 10 00 01 00 07 00 04 00-00 00 00 01 00 00 02 00  ................
:0010: 03 00 02 00 00 00 00 00-64 00 03 00 02 00 06 00  ........d.......

The data below is analyzed by Max Lyons .

Tag No. | Tag Name | Format | CompoNo | Value
0x0001 | Unknown | Undefined | 4 | Unknown. Always "0100". version?
0x0002 | ISO Setting | Unsigned short | 2 | 0,100=ISO 100 0,200=ISO200 0,400=ISO400 etc.
0x0003 | Color Mode | Ascii string | varies | "COLOR", "B&W"
0x0004 | Quality | Ascii string | varies | "NORMAL", "FINE", "BASIC"
0x0005 | Whitebalance | Ascii string | varies | "AUTO", "WHITE PRESET" etc.
0x0006 | Image Sharpening | Ascii string | varies | "AUTO", "HIGH" etc.
0x0007 | Focus Mode | Ascii string | varies | "AF-S" means Single AF, "AF-C" means Continuous AF.
0x0008 | Flash Setting | Ascii string | varies | "NORMAL", "RED-EYE" etc.
0x000a | Unknown | Unsigned rational | 1 | Unknown, Always '8832/1000'?
0x000f | ISO Selection | Ascii string | varies | "MANUAL":User selected, "AUTO":Automatically selected.
0x0080 | Image Adjustment | Ascii string | varies | "AUTO", "NORMAL", "CONTRAST(+)" etc.
0x0082 | Adapter | Ascii string | varies | "OFF", "FISHEYE 2", "WIDE ADAPTER" etc.
0x0085 | Manual Focus Distance | Unsigned rational | 1 | Distance in Meters if focus was manually selected, otherwise 0
0x0086 | Digital Zoom | Unsigned rational | 1 | '100/100' means no digital zoom (optical zoom only), '140/100' means 1.4x digital zoom.
0x0088 | AF Focus Position | Undefined | 4 | '0,0,0,0':Center, '0,1,0,0':Top, '0,2,0,0':Bottom, '0,3,0,0':Left, '0,4,0,0':right
0x0010 | Data Dump | Undefined | 174 | Unknown.

Appendix 3: MakerNote of Casio

Casio started to use Exif format from QV2000/QV8000. Casio's MakerNote format is the same as usual IFD (e.g. IFD0, SubIFD0). Example of actual data structure is shown below.
:0000: 00 14 00 01 00 03 00 00-00 01 00 0A 00 00 00 02 ................
:0010: 00 03 00 00 00 01 00 03-00 00 00 03 00 03 00 00 ................
The data below is analyzed by Eckhard Henkel .

Tag No. | Tag Name | Format | CompoNo | Value
0x0001 | RecordingMode | Unsigned Short | 1 | 1:Single Shutter, 2:Panorama, 3:Night Scene, 4:Portrait, 5:Landscape
0x0002 | Quality | Unsigned Short | 1 | 1:Economy, 2:Normal, 3:Fine
0x0003 | Focusing Mode | Unsigned Short | 1 | 2:Macro, 3:Auto Focus, 4:Manual Focus, 5:Infinity
0x0004 | Flash Mode | Unsigned Short | 1 | 1:Auto, 2:On, 3:Off, 4:Red Eye Reduction
0x0005 | Flash Intensity | Unsigned Short | 1 | 11:Weak, 13:Normal, 15:Strong
0x0006 | Object distance | Unsigned Long | 1 | Object distance in [mm]
0x0007 | White Balance | Unsigned Short | 1 | 1:Auto, 2:Tungsten, 3:Daylight, 4:Fluorescent, 5:Shade, 129:Manual
0x0008 | Unknown | Unsigned short | 1 | Unknown
0x0009 | Unknown | Unsigned short | 1 | Unknown
0x000a | Digital Zoom | Unsigned Long | 1 | 0x10000(65536):'Off', 0x10001(65537):'2X Digital Zoom'
0x000b | Sharpness | Unsigned Short | 1 | 0:Normal, 1:Soft, 2:Hard
0x000c | Contrast | Unsigned Short | 1 | 0:Normal, 1:Low, 2:High
0x000d | Saturation | Unsigned Short | 1 | 0:Normal, 1:Low, 2:High
0x000e | Unknown | Unsigned short | 1 | Unknown
0x000f | Unknown | Unsigned short | 1 | Unknown
0x0010 | Unknown | Unsigned short | 1 | Unknown
0x0011 | Unknown | Unsigned long | 1 | Unknown
0x0012 | Unknown | Unsigned short | 1 | Unknown
0x0013 | Unknown | Unsigned short | 1 | Unknown
0x0014 | CCD Sensitivity | Unsigned short | 1 | QV3000: 64:Normal, 125:+1.0, 250:+2.0, 244:+3.0 QV8000/2000: 80:Normal, 100:High

Appendix 4: MakerNote of Fujifilm

Fujifilm's digicam added the MakerNote tag from the Year2000's model (e.g.Finepix1400,Finepix4700). It uses IFD format and start from ASCII character 'FUJIFILM', and next 4 bytes(value 0x000c) points the offset to first IFD entry. Example of actual data structure is shown below.
:0000: 46 55 4A 49 46 49 4C 4D-0C 00 00 00 0F 00 00 00 :0000: FUJIFILM........
:0010: 07 00 04 00 00 00 30 31-33 30 00 10 02 00 08 00 :0010: ......0130......

There are two big differences to the other manufacturers.
  • Fujifilm's Exif data uses Motorola align, but MakerNote ignores it and uses Intel align.
  • The other manufacturer's MakerNote counts the "offset to data" from the first byte of TIFF header (same as the other IFD), but Fujifilm counts it from the first byte of MakerNote itself.
I think it's a BUG, but it can't be helped now... The data below is analyzed at Fujifilm FinePix4900Z.

Tag No. | Tag Name | Format | CompoNo | Value
0x0000 | Version | Undefined | 4 | Version of MakerNote information. At present, value is "0130".
0x1000 | Quality | Ascii string | 8 | Quality setting. Ascii string "BASIC","NORMAL","FINE"
0x1001 | Sharpness | Unsigned Short | 1 | Sharpness setting. 1or2:soft, 3:normal, 4or5:hard.
0x1002 | White Balance | Unsigned Short | 1 | White balance setting. 0:Auto, 256:Daylight, 512:Cloudy, 768:DaylightColor-fluorescence, 769:DaywhiteColor-fluorescence, 770:White-fluorescence, 1024:Incandenscense, 3840:Custom white balance.
0x1003 | Color | Unsigned Short | 1 | Chroma saturation setting. 0:normal(STD), 256:High, 512:Low(ORG).
0x1004 | Tone | Unsigned Short | 1 | Contrast setting. 0:normal(STD), 256:High(HARD), 512:Low(ORG).
0x1010 | Flash Mode | Unsigned Short | 1 | Flash firing mode setting. 0:Auto, 1:On, 2:Off, 3:Red-eye reduction.
0x1011 | Flash Strength | Signed Rational | 1 | Flash firing strength compensation setting. Unit is APEX(EV) and value is -6/10, -3/10, 0/10, 3/10, 6/10 etc.
0x1020 | Macro | Unsigned Short | 1 | Macro mode setting. 0:Off, 1:On.
0x1021 | Focus mode | Unsigned short | 1 | Focusing mode setting. 0:Auto focus, 1:Manual focus.
0x1030 | SlowSync. | Unsigned short | 1 | Slow synchro mode setting. 0:Off, 1:On.
0x1031 | Picture Mode | Unsigned short | 1 | Picture mode setting. 0:Auto, 1:Portrait scene, 2:Landscape scene, 4:Sports scene, 5:Night scene, 6:Program AE, 256:Aperture prior AE, 512:Shutter prior AE, 768:Manual exposure.
0x1032 | unknown | Unsigned Short | 1 | Unknown
0x1100 | ContTake/Bracket | Unsigned Short | 1 | Continuous taking or auto bracketting mode setting. 0:off, 1:on.
0x1200 | unknown | Unsigned Short | 1 | Unknown
0x1300 | Blur warning | Unsigned Short | 1 | Blur warning status. 0:No blur warning, 1:Blur warning.
0x1301 | Focus warning | Unsigned short | 1 | Auto Focus warning status. 0:Auto Focus good, 1:Out of focus.
0x1302 | AE warning | Unsigned short | 1 | Auto Exposure warning status. 0:AE good, 1:Over exposure (>1/1000s,F11).

Appendix 5: MakerNote of Canon

The data below was primarily analysed by David Burren and the master version of this information is available at: http://www.burren.cx/david/canon.html. Please send any updates to David.
This document is based on his Rev.1.11(2001/01/30) of document.

Canon's MakerNote data is in IFD format, starting at offset 0.

Some of these tags and fields are only produced on cameras such as the EOS D30, but (to current observation) all this is valid for all Canon digicams (at least since the A50). If the tag is not found, or is shorter than shown here, it simply means that data is not supported by that camera.

Tag No. | Tag Name | Format | CompoNo | Value
0x0 | Unknown | Unsigned Short | 6 | Always 0
0x1 Unknown Unsigned Short varies
Offset within tag | Meaning
0 | Length of tag in bytes (i.e. twice the number of shorts)
1 | Macro mode | 1: macro 2: normal
2 | If non-zero, length of self-timer in 10ths of a second
3 | unknown
4 | Flash mode | 0: flash not fired 1: auto 2: on 3: red-eye reduction 4: slow synchro 5: auto + red-eye reduction 6: on + red-eye reduction 16: external flash (not set on D30)
5 | Continuous drive mode | 0: single or timer (see field 2) 1: continuous
6 | unknown
7 | Focus Mode | 0: One-Shot 1: AI Servo 2: AI Focus 3: MF 4: Single (but check field 32) 5: Continuous 6: MF
8, 9 | unknown
10 | Image size | 0: large 1: medium 2: small
11 | "Easy shooting" mode | 0: Full Auto 1: Manual 2: Landscape 3: Fast Shutter 4: Slow Shutter 5: Night 6: B&W 7: Sepia 8: Portrait 9: Sports 10: Macro / Close-Up 11: Pan Focus
12 | unknown
13 | Contrast | 0xffff: low 0x0000: normal 0x0001: high
14 | Saturation | 0xffff: low 0x0000: normal 0x0001: high
15 | Sharpness | 0xffff: low 0x0000: normal 0x0001: high
16 | ISO | If zero, use ISOSpeedRatings EXIF tag instead 15: auto 16: 50 17: 100 18: 200 19: 400
17 | Metering mode | 3: Evaluative 4: Partial 5: Center-weighted
18 | unknown
19 | AF point selected | 0x3000: none (MF) 0x3001: auto-selected 0x3002: right 0x3003: center 0x3004: left
20 | Exposure mode | 0: "Easy shooting" (use field 11) 1: Program 2: Tv-priority 3: Av-priority 4: Manual 5: A-DEP
21, 22 | unknown
23 | "long" focal length of lens (in "focal units")
24 | "short" focal length of lens (in "focal units")
25 | "focal units" per mm
26 - 28 | unknown
29 | Flash details | Bits 15..0: 14: external E-TTL 13: internal flash 11: FP sync used 4: FP sync enabled other bits unknown
30 - 31 | unknown
32 | Focus mode | G1 seems to use this in preference to field 7 0: Single 1: Continuous
0x3 | Unknown | Unsigned Short | 4 | unknown
0x4 Unknown Unsigned Short varies
Offset within tag | Meaning
0 | Length of tag in bytes (i.e. twice the number of shorts)
1 - 6 | unknown
7 | White balance | 0: auto 1: Sunny 2: Cloudy 3: Tungsten 4: Flourescent 5: Flash 6: Custom
8 | unknown
9 | Sequence number (if in a continuous burst)
10 - 13 | unknown
14 | AF point used | Only set in One-Shot mode? If none used, AF failed or manual focus was used (e.g. on a lens with full-time manual focus) Bits 15..0: 15-12: number of available focus points 2: left 1: center 0: right
15 | Flash bias | 0xffc0: -2 EV 0xffcc: -1.67 EV 0xffd0: -1.50 EV 0xffd4: -1.33 EV 0xffe0: -1 EV 0xffec: -0.67 EV 0xfff0: -0.50 EV 0xfff4: -0.33 EV 0x0000: 0 EV 0x000c: 0.33 EV 0x0010: 0.50 EV 0x0014: 0.67 EV 0x0020: 1 EV 0x002c: 1.33 EV 0x0030: 1.50 EV 0x0034: 1.67 EV 0x0040: 2 EV
16 - 18 | unknown
19 | Subject Distance | Units are either 0.01m or 0.001m (both have been observed). Still investigating. In any case, the SubjectDistance EXIF tag is set by Canon cameras.
0x6 Image type Ascii string 32 e.g.: "IMG:EOS D30 JPEG"
Has trailing whitespace.
0x7 | Firmware version | Ascii string | 24 | May have trailing NULs and whitespace.
0x8 Image Number Unsigned Long 1 Normally reported as FFF-XXXX.
FFF is this value divided by 1000, XXXX is this value mod 1000.
0x9 | Owner name | Ascii string | 32 | May have trailing NULs and whitespace.
0xa | Unknown | Unsigned Short | varies | unknown
0xc Camera serial number Unsigned Long 1 High 16 bits are printed as a 4-digit hex number.
Low 16 bits are printed as a 5-digit decimal number.
These are concatenated to form the serial number. Example printf() format string would be "%04X%05d".
0xd | Unknown | Unsigned Short | varies | unknown
0xf Custom Functions Unsigned Short varies First short is the number of bytes in the tag (i.e. twice the number of shorts)
For each other value: the top 8 bits are the C.Fn number, and the lower 8 bits are the value.

EOS D30 Custom Functions

C.Fn | Name | Value
1 | Long exposure noise reduction | 0: Off 1: On
2 | Shutter/AE-lock buttons | 0: AF/AE lock 1: AE lock/AF 2: AF/AF lock 3: AE+release/AE+AF
3 | Mirror lockup | 0: Disable 1: Enable
4 | Tv/Av and exposure level | 0: 1/2 stop 1: 1/3 stop
5 | AF-assist light | 0: On (auto) 1: Off
6 | Shutter speed in Av mode | 0: Automatic 1: 1/200 (fixed)
7 | AEB sequence/auto cancellation | 0: 0, -, + / Enabled 1: 0, -, + / Disabled 2: -, 0, + / Enabled 3: -, 0, + / Disabled
8 | Shutter curtain sync | 0: 1st-curtain sync 1: 2nd-curtain sync
9 | Lens AF stop button Fn. Switch | 0: AF stop 1: Operate AF 2: Lock AE and start timer
10 | Auto reduction of fill flash | 0: Enable 1: Disable
11 | Menu button return position | 0: Top 1: Previous (volatile) 2: Previous
12 | SET button func. when shooting | 0: Not assigned 1: Change quality 2: Change ISO speed 3: Select parameters
13 | Sensor cleaning | 0: Disable 1: Enable

History

rev. 1.4

  • Added Makernote of Canon
  • Added Color/Tone TAGs to Fujifilm's makernote

rev. 1.3

  • Added Exif2.1 specification
  • Added Makernote of Fujifilm

rev. 1.2

  • Added DCF specification
  • Added Interoperability IFD
  • Added Makernote of Nikon/Casio

rev. 1.1

  • Added byte align explanation to TAG Mark of TIFF header
  • Corrected data format of some TAGs to "unsigned short/long"
  • Corrected value of FocalPlaneResolutionUnit
  • Added Appendix 1: MakerNote of Olympus

rev. 1.0

  • First release

Acknowledgement

I would like to thank to;

Daniel Switkin: Byte align of TAG Mark, Format of ImageWidth/ImageLength
Peter Esherick: MakerNote of Olympus
Matthias Wandel: Value of FocalPlaneResolutionUnit
Max Lyons: Makernote of Nikon ...His webpage
Eckhard Henkel: Makernote of Casio ...His webpage
David Burren: FocalPlaneResolutionUnit of Fujifilm's / Makernote of Canon ...His webpage


ThumbHTML - EXIF Data

ThumbHTML v2.7 - EXIF Data
Extracting EXchangable Image File Information from JPEG images

JPG images store additional picture information in the EXIF header of each file. ThumbHTML will extract a selection of the most useful data elements if available (editing and saving JPG files often destroys this information).

Whenever you browse to a new folder containing images, ThumbHTML will generate a file containing the EXIF data with these images and save it to that folder as exifdata.txt [example]. The format of this data file, in which each field is delimited by the | symbol, is suitable for import to a database or Excel.

If the EXIF data are not available, the program uses the existing date and time, and filesize, of the file. All this information, together with the picture comments entered by the user, can be exported to a file 'pictureinfo.txt' by using the appropriate menu item.

If you check the menu item "Display EXIF data with thumbnails" on the Tools menu, ThumbHTML will display the EXIF data as you browse through the set of images, giving a display like that shown on the right
ThumbHTML can add picture information to the output web pages - either the individual linked HTML pages or the slideshow page.

You can tell the program which items to add by selecting the EXIF item from the Tools menu brings up this dialog on the right. You just choose the element you would like to be added.

More information about the Exif file format.

Back to the main page
© Jeff Waldock


ThumbHTML - Templates

ThumbHTML v2.7 - TEMPLATES
TEMPLATES

Where stylesheets control the appearance of the elements of the HTML pages, and the items chosen by the user in ThumbHTML select what is to appear, the idea of the template is to allow control over where this information is placed.

The way this is done is to create a template for each type of web page produced by ThumbHTML: (1) the thumbnail pages, (2) the individual linked pages and (3) the slideshow page. The template comprises HTML, placeholders (which are replaced with the corresponding picture data by ThumbHTML) and comments to help users to modify them. Currently, only one set of templates exists, and to modify these you will have to edit them directly - they are stored in a sub-folder called 'templates' of the main ThumbHTML folder. A future enhancement of the program will provide a front-end for this.

Each of these three templates is described below:

Thumbnail template
Listed below are the placeholders available for the thumbnail HTML pages. To view the default template that uses these, click [here]

  <!--title-->              Page title
  <!--pagenumber-->         Page number
  <!--images-->             Block of code containing images and formatting for the page
  <!--slideshowlink-->      Text of slideshow link
  <!--otherpagelinks-->     Text for links to other pages
  <!--progver-->            ThumbHTML version
  <!--date(mm/dd/yyyy)-->   Current date (replace date format as required)
  <!--time(hh:mm)-->        Current time (replace time format as required)
  <!--year-->               Current year

Individual template
Listed below are the placeholders available for the individual HTML pages. To view the default template that uses these, click [here]

  <!--title-->              Page title
  <!--imagenumber-->        Image number
  <!--imagenumberfilenamerow-->  Image number and filename on one row
  <!--filename-->           Filename
  <!--photodatetime-->      Date and time of image
  <!--photodata-->          Picture data
  <!--leftnavlinks-->       Navigation links (left)
  <!--mainpicture-->        Block of code containing the image itself
  <!--rightnavlinks-->      Navigation links (right)
  <!--copyright-->          Copyright information, if it exists
  <!--caption-->            Picture comments/caption
  <!--backtolink-->         Link to calling page and home page (if different)
  <!--alsoavailable-->      Links to other sizes of this image
  <!--progver-->            ThumbHTML version
  <!--date(mm/dd/yyyy)-->   Current date (replace date format as required)
  <!--time(hh:mm)-->        Current time (replace time format as required)
  <!--year-->               Current year

Slideshow template
Listed below are the placeholders available for the slideshow HTML page. To view the default template that uses these, click [here]

 <!--title-->              Page title
 <!--filename-->           Filename
 <!--imagecount-->         Image count
 <!--photodate-->          Photo datetime
 <!--photodetails-->       Photo details
 <!--descriptions-->       Photo comments
 <!--image-->              The actual image
 <!--mainimagepagelink-->  Link to main image thumbnail page
 <!--progver-->            ThumbHTML version
 <!--date(mm/dd/yyyy)-->   Current date (replace date format as required)
 <!--time(hh:mm)-->        Current time (replace time format as required)

Back to the main page
© Jeff Waldock


ThumbHTML - Futures

ThumbHTML v2.7 - Future Plans
Futures

Here is a list of possible future enhancements, some proposed by me but most suggested by existing users. These are all scheduled for inclusion in future versions of the program, but I can't say exactly WHEN each will happen! Please e-mail me to suggest others, or to support one or more of these!

  • Create a Frequently Asked Questions list - this will save me having to e-mail replies to the same questions!

  • In response to a number of requests which have been made for a greater degree of control over the information offered on the pages created by ThumbHTML, I have introduced templates and stylesheets. At the moment, the facility of a single set of templates only exists, but I hope to be able to offer a way for users to choose from 'sets' of templates for their web albums.

  • Alternative ways of presenting thumbnails/linked pictures:
    • Framesets (Thumbs in one frame, linked images in the other)
    • Text links, rather than Thumbnails

  • More flexibility in the batch image feature - e.g. the ability to be able to select different characteristics for each size (quality, shadow/no shadow, etc)

  • Greater control over headers/footers - e.g. sub-headers etc

  • Allow users to choose an image for the home/back links

  • Allow users to replace all text elements with their own (helps with other languages)

Back to the main page
© Jeff Waldock


exifdata.txt

Filename|Size|Make|Model|DateOrig|TimeOrig|DateMod|TimeMod|Width|Height|Exposure|FocalLength|Aperture|Compression|Metering|ISO|Program|Copyright|EXIFVersion|ImageNumber|Comment|Description|Artist
DSCN3338.JPG|538K|NIKON|E995|19/01/2003|14:23|19/01/2003|14:23|1280|960|1/57s|22.9mm|f4.2|4/1|Multi-Segment|100|Program||0210|0|||
DSCN3339.JPG|552K|NIKON|E995|19/01/2003|14:23|19/01/2003|14:23|1280|960|1/72s|18.4mm|f3.7|4/1|Multi-Segment|100|Program||0210|0|||
DSCN3340.JPG|517K|NIKON|E995|19/01/2003|14:33|19/01/2003|14:33|1280|960|1/175s|8.2mm|f3.7|4/1|Multi-Segment|100|Program||0210|0|||
DSCN3341.JPG|479K|NIKON|E995|19/01/2003|14:33|19/01/2003|14:33|1280|960|1/60s|29.3mm|f4.9|4/1|Multi-Segment|100|Program||0210|0|||
DSCN3342.JPG|485K|NIKON|E995|19/01/2003|14:34|19/01/2003|14:34|1280|960|1/69s|22.9mm|f4.2|4/1|Multi-Segment|100|Program||0210|0|||
DSCN3343.JPG|464K|NIKON|E995|19/01/2003|16:09|19/01/2003|16:09|1280|960|1/170s|9.6mm|f4.0|4/1|Multi-Segment|100|Program||0210|0|||
DSCN3344.JPG|496K|NIKON|E995|19/01/2003|16:09|19/01/2003|16:09|1280|960|1/109s|31.0mm|f5.1|4/1|Multi-Segment|100|Program||0210|0|||
DSCN3345.JPG|494K|NIKON|E995|19/01/2003|16:09|19/01/2003|16:09|1280|960|1/148s|31.0mm|f5.1|4/1|Multi-Segment|100|Program||0210|0|||
DSCN3346.JPG|524K|NIKON|E995|19/01/2003|16:27|19/01/2003|16:27|1280|960|1/171s|8.2mm|f4.2|4/1|Multi-Segment|100|Program||0210|0|||
DSCN3347.JPG|567K|NIKON|E995|19/01/2003|16:27|19/01/2003|16:27|1280|960|1/158s|8.2mm|f3.7|4/1|Multi-Segment|100|Program||0210|0|||
DSCN3348.JPG|509K|NIKON|E995|19/01/2003|16:28|19/01/2003|16:28|1280|960|1/124s|26.9mm|f4.6|4/1|Multi-Segment|100|Program||0210|0|||
DSCN3349.JPG|520K|NIKON|E995|19/01/2003|16:28|19/01/2003|16:28|1280|960|1/154s|20.8mm|f4.6|4/1|Multi-Segment|100|Program||0210|0|||
DSCN3350.JPG|525K|NIKON|E995|19/01/2003|16:28|19/01/2003|16:28|1280|960|1/213s|11.5mm|f4.8|4/1|Multi-Segment|100|Program||0210|0|||
DSCN3351.JPG|515K|NIKON|E995|19/01/2003|16:28|19/01/2003|16:28|1280|960|1/179s|8.2mm|f5.3|4/1|Multi-Segment|100|Program||0210|0|||
DSCN3352.JPG|461K|NIKON|E995|19/01/2003|16:28|19/01/2003|16:28|1280|960|1/210s|8.2mm|f4.7|4/1|Multi-Segment|100|Program||0210|0|||
DSCN3353.JPG|472K|NIKON|E995|19/01/2003|16:29|19/01/2003|16:29|1280|960|1/210s|8.2mm|f5.3|4/1|Multi-Segment|100|Program||0210|0|||
DSCN3354.JPG|517K|NIKON|E995|19/01/2003|16:29|19/01/2003|16:29|1280|960|1/324s|8.2mm|f6.0|4/1|Multi-Segment|100|Program||0210|0|||
DSCN3355.JPG|534K|NIKON|E995|19/01/2003|16:29|19/01/2003|16:29|1280|960|1/205s|20.0mm|f4.4|4/1|Multi-Segment|100|Program||0210|0|||
DSCN3356.JPG|454K|NIKON|E995|19/01/2003|16:30|19/01/2003|16:30|1280|960|1/198s|8.2mm|f5.3|4/1|Multi-Segment|100|Program||0210|0|||
DSCN3357.JPG|442K|NIKON|E995|19/01/2003|16:30|19/01/2003|16:30|1280|960|1/169s|8.2mm|f3.7|4/1|Multi-Segment|100|Program||0210|0|||
DSCN3358.JPG|434K|NIKON|E995|19/01/2003|16:31|19/01/2003|16:31|1280|960|1/140s|8.2mm|f3.3|4/1|Multi-Segment|100|Program||0210|0|||
DSCN3359.JPG|457K|NIKON|E995|19/01/2003|16:31|19/01/2003|16:31|1280|960|1/251s|8.2mm|f6.0|4/1|Multi-Segment|100|Program||0210|0|||
DSCN3360.JPG|480K|NIKON|E995|19/01/2003|16:32|19/01/2003|16:32|1280|960|1/225s|31.0mm|f5.8|4/1|Multi-Segment|100|Program||0210|0|||
DSCN3361.JPG|457K|NIKON|E995|19/01/2003|16:34|19/01/2003|16:34|1280|960|1/114s|26.9mm|f4.6|4/1|Multi-Segment|100|Program||0210|0|||
DSCN3362.JPG|455K|NIKON|E995|19/01/2003|16:34|19/01/2003|16:34|1280|960|1/145s|26.9mm|f4.6|4/1|Multi-Segment|100|Program||0210|0|||
DSCN3363.JPG|436K|NIKON|E995|19/01/2003|16:34|19/01/2003|16:34|1280|960|1/205s|26.9mm|f5.3|4/1|Multi-Segment|100|Program||0210|0|||


picturedata.txt

FileName: DSCN3338.JPG
FileSize: 538K
Make: NIKON
Model: E995
Date Original: 19/01/2003
Time Original: 14:23
Date Modified: 19/01/2003
Time Modified: 14:23
Width: 1280
Height: 960
Exposure: 1/57s
Focal Length: 22.9mm
Aperture: f4.2
Compression: 4/1
Metering: Multi-Segment
ISO: 100
Program: Program
Copyright:
EXIF Version: 0210
Image Number: 0
Comment: A hut at Bridlington!
Description:

FileName: DSCN3339.JPG
FileSize: 552K
Make: NIKON
Model: E995
Date Original: 19/01/2003
Time Original: 14:23
Date Modified: 19/01/2003
Time Modified: 14:23
Width: 1280
Height: 960
Exposure: 1/72s
Focal Length: 18.4mm
Aperture: f3.7
Compression: 4/1
Metering: Multi-Segment
ISO: 100
Program: Program
Copyright:
EXIF Version: 0210
Image Number: 0
Comment:
Description:

FileName: DSCN3340.JPG
FileSize: 517K
Make: NIKON
Model: E995
Date Original: 19/01/2003
Time Original: 14:33
Date Modified: 19/01/2003
Time Modified: 14:33
Width: 1280
Height: 960
Exposure: 1/175s
Focal Length: 8.2mm
Aperture: f3.7
Compression: 4/1
Metering: Multi-Segment
ISO: 100
Program: Program
Copyright:
EXIF Version: 0210
Image Number: 0
Comment: Grey day at the seaside
Description:

FileName: DSCN3341.JPG
FileSize: 479K
Make: NIKON
Model: E995
Date Original: 19/01/2003
Time Original: 14:33
Date Modified: 19/01/2003
Time Modified: 14:33
Width: 1280
Height: 960
Exposure: 1/60s
Focal Length: 29.3mm
Aperture: f4.9
Compression: 4/1
Metering: Multi-Segment
ISO: 100
Program: Program
Copyright:
EXIF Version: 0210
Image Number: 0
Comment:
Description:

FileName: DSCN3342.JPG
FileSize: 485K
Make: NIKON
Model: E995
Date Original: 19/01/2003
Time Original: 14:34
Date Modified: 19/01/2003
Time Modified: 14:34
Width: 1280
Height: 960
Exposure: 1/69s
Focal Length: 22.9mm
Aperture: f4.2
Compression: 4/1
Metering: Multi-Segment
ISO: 100
Program: Program
Copyright:
EXIF Version: 0210
Image Number: 0
Comment:
Description:

FileName: DSCN3343.JPG
FileSize: 464K
Make: NIKON
Model: E995
Date Original: 19/01/2003
Time Original: 16:09
Date Modified: 19/01/2003
Time Modified: 16:09
Width: 1280
Height: 960
Exposure: 1/170s
Focal Length: 9.6mm
Aperture: f4.0
Compression: 4/1
Metering: Multi-Segment
ISO: 100
Program: Program
Copyright:
EXIF Version: 0210
Image Number: 0
Comment: View of Bridlington beach
Description:

FileName: DSCN3344.JPG
FileSize: 496K
Make: NIKON
Model: E995
Date Original: 19/01/2003
Time Original: 16:09
Date Modified: 19/01/2003
Time Modified: 16:09
Width: 1280
Height: 960
Exposure: 1/109s
Focal Length: 31.0mm
Aperture: f5.1
Compression: 4/1
Metering: Multi-Segment
ISO: 100
Program: Program
Copyright:
EXIF Version: 0210
Image Number: 0
Comment:
Description:

FileName: DSCN3345.JPG
FileSize: 494K
Make: NIKON
Model: E995
Date Original: 19/01/2003
Time Original: 16:09
Date Modified: 19/01/2003
Time Modified: 16:09
Width: 1280
Height: 960
Exposure: 1/148s
Focal Length: 31.0mm
Aperture: f5.1
Compression: 4/1
Metering: Multi-Segment
ISO: 100
Program: Program
Copyright:
EXIF Version: 0210
Image Number: 0
Comment:
Description:

FileName: DSCN3346.JPG
FileSize: 524K
Make: NIKON
Model: E995
Date Original: 19/01/2003
Time Original: 16:27
Date Modified: 19/01/2003
Time Modified: 16:27
Width: 1280
Height: 960
Exposure: 1/171s
Focal Length: 8.2mm
Aperture: f4.2
Compression: 4/1
Metering: Multi-Segment
ISO: 100
Program: Program
Copyright:
EXIF Version: 0210
Image Number: 0
Comment:
Description:

FileName: DSCN3347.JPG
FileSize: 567K
Make: NIKON
Model: E995
Date Original: 19/01/2003
Time Original: 16:27
Date Modified: 19/01/2003
Time Modified: 16:27
Width: 1280
Height: 960
Exposure: 1/158s
Focal Length: 8.2mm
Aperture: f3.7
Compression: 4/1
Metering: Multi-Segment
ISO: 100
Program: Program
Copyright:
EXIF Version: 0210
Image Number: 0
Comment:
Description:

FileName: DSCN3348.JPG
FileSize: 509K
Make: NIKON
Model: E995
Date Original: 19/01/2003
Time Original: 16:28
Date Modified: 19/01/2003
Time Modified: 16:28
Width: 1280
Height: 960
Exposure: 1/124s
Focal Length: 26.9mm
Aperture: f4.6
Compression: 4/1
Metering: Multi-Segment
ISO: 100
Program: Program
Copyright:
EXIF Version: 0210
Image Number: 0
Comment:
Description:

FileName: DSCN3349.JPG
FileSize: 520K
Make: NIKON
Model: E995
Date Original: 19/01/2003
Time Original: 16:28
Date Modified: 19/01/2003
Time Modified: 16:28
Width: 1280
Height: 960
Exposure: 1/154s
Focal Length: 20.8mm
Aperture: f4.6
Compression: 4/1
Metering: Multi-Segment
ISO: 100
Program: Program
Copyright:
EXIF Version: 0210
Image Number: 0
Comment:
Description:

FileName: DSCN3350.JPG
FileSize: 525K
Make: NIKON
Model: E995
Date Original: 19/01/2003
Time Original: 16:28
Date Modified: 19/01/2003
Time Modified: 16:28
Width: 1280
Height: 960
Exposure: 1/213s
Focal Length: 11.5mm
Aperture: f4.8
Compression: 4/1
Metering: Multi-Segment
ISO: 100
Program: Program
Copyright:
EXIF Version: 0210
Image Number: 0
Comment:
Description:

FileName: DSCN3351.JPG
FileSize: 515K
Make: NIKON
Model: E995
Date Original: 19/01/2003
Time Original: 16:28
Date Modified: 19/01/2003
Time Modified: 16:28
Width: 1280
Height: 960
Exposure: 1/179s
Focal Length: 8.2mm
Aperture: f5.3
Compression: 4/1
Metering: Multi-Segment
ISO: 100
Program: Program
Copyright:
EXIF Version: 0210
Image Number: 0
Comment:
Description:

FileName: DSCN3352.JPG
FileSize: 461K
Make: NIKON
Model: E995
Date Original: 19/01/2003
Time Original: 16:28
Date Modified: 19/01/2003
Time Modified: 16:28
Width: 1280
Height: 960
Exposure: 1/210s
Focal Length: 8.2mm
Aperture: f4.7
Compression: 4/1
Metering: Multi-Segment
ISO: 100
Program: Program
Copyright:
EXIF Version: 0210
Image Number: 0
Comment:
Description:

FileName: DSCN3353.JPG
FileSize: 472K
Make: NIKON
Model: E995
Date Original: 19/01/2003
Time Original: 16:29
Date Modified: 19/01/2003
Time Modified: 16:29
Width: 1280
Height: 960
Exposure: 1/210s
Focal Length: 8.2mm
Aperture: f5.3
Compression: 4/1
Metering: Multi-Segment
ISO: 100
Program: Program
Copyright:
EXIF Version: 0210
Image Number: 0
Comment:
Description:

FileName: DSCN3354.JPG
FileSize: 517K
Make: NIKON
Model: E995
Date Original: 19/01/2003
Time Original: 16:29
Date Modified: 19/01/2003
Time Modified: 16:29
Width: 1280
Height: 960
Exposure: 1/324s
Focal Length: 8.2mm
Aperture: f6.0
Compression: 4/1
Metering: Multi-Segment
ISO: 100
Program: Program
Copyright:
EXIF Version: 0210
Image Number: 0
Comment:
Description:

FileName: DSCN3355.JPG
FileSize: 534K
Make: NIKON
Model: E995
Date Original: 19/01/2003
Time Original: 16:29
Date Modified: 19/01/2003
Time Modified: 16:29
Width: 1280
Height: 960
Exposure: 1/205s
Focal Length: 20.0mm
Aperture: f4.4
Compression: 4/1
Metering: Multi-Segment
ISO: 100
Program: Program
Copyright:
EXIF Version: 0210
Image Number: 0
Comment:
Description:

FileName: DSCN3356.JPG
FileSize: 454K
Make: NIKON
Model: E995
Date Original: 19/01/2003
Time Original: 16:30
Date Modified: 19/01/2003
Time Modified: 16:30
Width: 1280
Height: 960
Exposure: 1/198s
Focal Length: 8.2mm
Aperture: f5.3
Compression: 4/1
Metering: Multi-Segment
ISO: 100
Program: Program
Copyright:
EXIF Version: 0210
Image Number: 0
Comment:
Description:

FileName: DSCN3357.JPG
FileSize: 442K
Make: NIKON
Model: E995
Date Original: 19/01/2003
Time Original: 16:30
Date Modified: 19/01/2003
Time Modified: 16:30
Width: 1280
Height: 960
Exposure: 1/169s
Focal Length: 8.2mm
Aperture: f3.7
Compression: 4/1
Metering: Multi-Segment
ISO: 100
Program: Program
Copyright:
EXIF Version: 0210
Image Number: 0
Comment:
Description:

FileName: DSCN3358.JPG
FileSize: 434K
Make: NIKON
Model: E995
Date Original: 19/01/2003
Time Original: 16:31
Date Modified: 19/01/2003
Time Modified: 16:31
Width: 1280
Height: 960
Exposure: 1/140s
Focal Length: 8.2mm
Aperture: f3.3
Compression: 4/1
Metering: Multi-Segment
ISO: 100
Program: Program
Copyright:
EXIF Version: 0210
Image Number: 0
Comment:
Description:

FileName: DSCN3359.JPG
FileSize: 457K
Make: NIKON
Model: E995
Date Original: 19/01/2003
Time Original: 16:31
Date Modified: 19/01/2003
Time Modified: 16:31
Width: 1280
Height: 960
Exposure: 1/251s
Focal Length: 8.2mm
Aperture: f6.0
Compression: 4/1
Metering: Multi-Segment
ISO: 100
Program: Program
Copyright:
EXIF Version: 0210
Image Number: 0
Comment:
Description:

FileName: DSCN3360.JPG
FileSize: 480K
Make: NIKON
Model: E995
Date Original: 19/01/2003
Time Original: 16:32
Date Modified: 19/01/2003
Time Modified: 16:32
Width: 1280
Height: 960
Exposure: 1/225s
Focal Length: 31.0mm
Aperture: f5.8
Compression: 4/1
Metering: Multi-Segment
ISO: 100
Program: Program
Copyright:
EXIF Version: 0210
Image Number: 0
Comment:
Description:

FileName: DSCN3361.JPG
FileSize: 457K
Make: NIKON
Model: E995
Date Original: 19/01/2003
Time Original: 16:34
Date Modified: 19/01/2003
Time Modified: 16:34
Width: 1280
Height: 960
Exposure: 1/114s
Focal Length: 26.9mm
Aperture: f4.6
Compression: 4/1
Metering: Multi-Segment
ISO: 100
Program: Program
Copyright:
EXIF Version: 0210
Image Number: 0
Comment:
Description:

FileName: DSCN3362.JPG
FileSize: 455K
Make: NIKON
Model: E995
Date Original: 19/01/2003
Time Original: 16:34
Date Modified: 19/01/2003
Time Modified: 16:34
Width: 1280
Height: 960
Exposure: 1/145s
Focal Length: 26.9mm
Aperture: f4.6
Compression: 4/1
Metering: Multi-Segment
ISO: 100
Program: Program
Copyright:
EXIF Version: 0210
Image Number: 0
Comment:
Description:

FileName: DSCN3363.JPG
FileSize: 436K
Make: NIKON
Model: E995
Date Original: 19/01/2003
Time Original: 16:34
Date Modified: 19/01/2003
Time Modified: 16:34
Width: 1280
Height: 960
Exposure: 1/205s
Focal Length: 26.9mm
Aperture: f5.3
Compression: 4/1
Metering: Multi-Segment
ISO: 100
Program: Program
Copyright:
EXIF Version: 0210
Image Number: 0
Comment:
Description:


thumbnail.txt

<!---------------------------------------------------------------------------------------
  ThumbHTML - thumbnails template
  -------------------------------

  This is the template for the HTML pages generated by ThumbHTML for the thumbnails
  You can edit this as necessary to customise the appearance of your pages.
  The following 'macro' elements are available, and will be substituted with the corresponding
  item by ThumbHTML wherever they appear in the template:

  <!--title-->              Page title
  <!--pagenumber-->         Page number
  <!--images-->             Block of code containing images and formatting for the page
  <!--slideshowlink-->      Text of slideshow link
  <!--otherpagelinks-->     Text for links to other pages
  <!--progver-->            ThumbHTML version
  <!--date(mm/dd/yyyy)-->   Current date (replace date format as required)
  <!--time(hh:mm)-->        Current time (replace time format as required)
  <!--year-->               Current year

  Jeff Waldock, January 31, 2003.
------------------------------------------------------------------------------------------>
<html><head>
<meta name="generator" content="ThumbHTML v<!--progver-->">
<title><!--title--></title>
<link rel="stylesheet" type="Text/css" href="photos.css">
</head>
<body>
<center>
<H1><!--title--> <!--pagenumber--></H1>
<p>
<!--images-->
<p>Click on the thumbnail for a larger version!&nbsp;&nbsp;&nbsp;&nbsp;
<!--slideshowlink-->
</p><p>
<!--otherpagelinks-->
</p></center>
<p><hr size=1>
<div class="footer">
Created with <a href="http://landscapeimage.com/photos/downloads/ThumbHTML/" class="footer">ThumbHTML v<!--progver--></a>
<br> &copy; Jeff Waldock, <!--year-->
</div>
</body>
</html>


linkedimage.txt

<!---------------------------------------------------------------------------------------
  ThumbHTML - Linked image template
  -------------------------------

  This is the template for the HTML pages generated by ThumbHTML for each individual image
  You can edit this as necessary to customise the appearance of your pages.
  The following 'macro' elements are available, and will be substituted with the corresponding
  item by ThumbHTML wherever they appear in the template:

  <!--title-->              Page title
  <!--imagenumber-->        Image number
  <!--imagenumberfilenamerow-->  Image number and filename on one row
  <!--filename-->           Filename
  <!--photodatetime-->      Date and time of image
  <!--photodata-->          Picture data
  <!--leftnavlinks-->       Navigation links (left)
  <!--mainpicture-->        Block of code containing the image itself
  <!--rightnavlinks-->      Navigation links (right)
  <!--copyright-->          Copyright information, if it exists
  <!--caption-->            Picture comments/caption
  <!--backtolink-->         Link to calling page and home page (if different)
  <!--alsoavailable-->      Links to other sizes of this image
  <!--progver-->            ThumbHTML version
  <!--date(mm/dd/yyyy)-->   Current date (replace date format as required)
  <!--time(hh:mm)-->        Current time (replace time format as required)
  <!--year-->               Current year

  Jeff Waldock, January 31, 2003.
------------------------------------------------------------------------------------------>
<html><head>
<meta name="generator" content="ThumbHTML v<!--progver-->">
<title><!--title--></title>
<script language="JavaScript">
<!--
if (document.images) {
var start1 = new Image()
start1.src = "navstart.gif"
var start2 = new Image()
start2.src = "navstartu.gif"
var back1 = new Image()
back1.src = "navleft.gif"
var back2 = new Image()
back2.src = "navleftu.gif"
var next1 = new Image()
next1.src = "navright.gif"
var next2 = new Image()
next2.src = "navrightu.gif"
var end1 = new Image()
end1.src = "navend.gif"
var end2 = new Image()
end2.src = "navendu.gif"
}
function act(imgName) {
if (document.images) document[imgName].src=eval(imgName+'2.src')
}
function inact(imgName) {
if (document.images) document[imgName].src=eval(imgName+'1.src')
}
//-->
</script>
<link rel="stylesheet" type="text/css" href="photos.css">
</head>
<body>
<center>
<H1><!--title--></H1>
<hr size=1 width="50%" align="center">
<table width="610" cellpadding="0" cellspacing="2">
<!--imagenumberfilenamerow-->
<tr><td class="photodatetime"><!--photodatetime--></td><td class="photodata"><!--photodata--></td></tr>
</table>
<table cellpadding="0" cellspacing="0"><tr><td>
<!--leftnavlinks-->
<!--mainpicture-->
<!--rightnavlinks-->
</td></tr></table>
<table cellpadding="0" cellspacing="0" width="610">
<tr><td colspan="2" class="photodata"><!--copyright--></td></tr>
<tr><td colspan="2" class="caption"><!--caption--></td></tr>
<tr><td colspan="2">&nbsp;</td></tr>
<tr><td valign="top">
<!--backtolink-->&nbsp;
</td>
<td valign="top" width="100%" class="alsoavailable">
Also available:<br><!--alsoavailable-->
</td></tr>
</table>
</center>
<p><hr size="1">
<div class="footer">
Created with <a href="http://landscapeimage.com/photos/downloads/ThumbHTML/" class="footer">ThumbHTML v<!--progver--></a>
<br> &copy; Jeff Waldock, <!--year-->
<br>
<font color="silver" size="1">Saved <!--date(mmmm d, yyyy)--> <!--time(hh:mm)--></font>
</div>
</body></html>


slideshow.txt

<!---------------------------------------------------------------------------------------
  ThumbHTML - slideshow template
  -------------------------------

  This is the template for the slideshow page generated by ThumbHTML.
  You can edit this as necessary to customise the appearance of your pages.
  the following 'macro' elements are available, and will be substituted with the corresponding
  item by ThumbHTML wherever they appear in the template:

  <!--title-->              Page title
  <!--filename-->           Filename
  <!--imagecount-->         Image count
  <!--photodate-->          Photo datetime
  <!--photodetails-->       Photo details
  <!--descriptions-->       Photo comments
  <!--image-->              The actual image
  <!--mainimagepagelink-->  Link to main image thumbnail page
  <!--progver-->            ThumbHTML version
  <!--date(mm/dd/yyyy)-->   Current date (replace date format as required)
  <!--time(hh:mm)-->        Current time (replace time format as required)

  Note: the </head> tag is replaced by all the necessary header info (i.e. the Javascript)
  which carries out the slideshow by ThumbHTML.

  Jeff Waldock, January 31, 2003.
------------------------------------------------------------------------------------------>
<html><head>
<meta name="generator" content="ThumbHTML v<!--progver-->">
<title><!--title--></title>
<link rel="stylesheet" type="text/css" href="photos.css">
</head>
<body onload="doSShow()">
<center>
<H1><!--title--></H1>
<hr size="1" width="50%" align="center">
<table border="0" cellpadding="0" cellspacing="0">
<tr><td colspan="2"><!--filename-->&nbsp;<!--imagecount--></td></tr>
<tr>
  <td height="25"><!--photodate--></td>
  <td align="right" height="25"><!--photodetails--></td>
</tr>
<tr><td id="mainimage" colspan="2" align="center"><!--image--><br><!--descriptions--></td></tr>
</table>
<!--mainimagepagelink-->
</center>
<p><hr size="1">
<div class="footer">
Created with <a href="http://landscapeimage.com/photos/downloads/ThumbHTML/" class="footer">ThumbHTML v<!--progver--></a>
<br> &copy; Jeff Waldock, <!--year-->
</div>
</body></html>


default.css

/*-----------------------------------------*/
/* ThumbHTML default stylesheet            */
/* version 2.7, Jeff Waldock, January 2003 */
/*-----------------------------------------*/

/* Governs page background, and background of images using drop-shadows */
BODY {
background-color: #006699;
color: #FFFFFF;
font-family: Verdana, Geneva, Arial, Helvetica, Sans-Serif;
font-size: 12px;
}

/* links */
A:LINK {
font-family: Verdana, Geneva, Arial, Helvetica, Sans-Serif;
font-size: 12px;
color:#0099FF;
font-weight : normal;
text-decoration : none;
}

/* visited links */
A:VISITED {
font-family: Verdana, Geneva, Arial, Helvetica, Sans-Serif;
font-size: 12px;
color: #FFCC99;
font-weight : normal;
text-decoration : none;
}

/* mouse-over links */
A:HOVER {
font-family: Verdana, Geneva, Arial, Helvetica, Sans-Serif;
font-size: 12px;
color: #0099FF;
font-weight : normal;
text-decoration: underline;
}

/* footer text */
DIV.footer {
color: #FFFFFF;
font-size: 10px;
}

/* main title */
H1 {
font-family: Verdana, Geneva, Arial, Helvetica, Sans-Serif;
font-weight : Normal;
color: #FFFFFF;
font-size: 20px;
}

/* not currently used - has been replaced by <center> tags */
.mainbody {
 text-align: center;
}

/* date and time */
.photodatetime {
color: #FFFF00;
font-size: 10px;
}

/* photo data section */
.photodata {
color: #C0C0C0;
font-size: 10px;
text-align: right;
}

/* picture comments */
.caption {
color: #33FF33;
font-size: 12px;
text-align: center;
}

/* link colors in the footer section */
A.footer, A:VISITED.footer {
font-size: 10px;
}

/* mouseover-color of hyperlinks in the footer section */
A:HOVER.footer {
font-size: 10px;
color: #0099FF;
}

TD {
color: #33FF33;
font-family: Verdana, Geneva, Arial, Helvetica, Sans-Serif;
font-size: 12px;
}

/* text in the 'also-available' section of linked-image HTML pages */
TD.alsoavailable {
color: #33FF33;
font-size: 10px;
}

/* Hyperlinks in 'also-available' section of individual linked-image HTML pages */
A.alsoavailable,A:HOVER.alsoavailable,A:VISITED.alsoavailable {
font-size: 10px;
}

/* image descriptions in slideshow */
#descriptions {
color: #33FF33;
font-size: 12px;
text-align: center;
font-style: italic;
}

/* picture information in slideshow */
#photodetails {
color: #C0C0C0;
font-size: 11px;
text-align: right;
}

/* photo date and time in slideshow */
#photodate {
color: #FFFF00;
font-size: 11px;
}

/* image filename in slideshow */
#filename {
color: #C0C0C0;
font-size: 12px;
text-align: left;
}

/* image count in slideshow */
#imagecount {
font-size: 12px;
text-align: left;
}


ThumbHTML - Introduction

ThumbHTML v2.7

This program helps you to generate quick HTML pages of your digital photographs.

Run the program, choose the directory containing the images you wish to use, click "Create Thumbnails", click "Create HTML" and you're done!
All that remains is to upload the contents of the folder to your web server or ISP account.

For more details, follow one of these links...

Quick-Start
Detailed Step-by-step guide

1: Resizing Your Main Images ...
  • Structuring your photo folders
  • Creating thumbnails (and other sizes)
  • Drop shadows and background colours
  • Batch processing
  • Adding a text watermark
  • Additional image processing functions
2: Adding Picture Information
  • Adding picture comments
3: Creating Your Web Pages
  • Choosing colours
  • Choosing styles
  • Providing photo details
  • Sorting the images
  • Custom footers
  • Generating the HTML pages
  • Creating a slide-show
4: General
  • Creating custom profiles
  • Creating custom templates
© Jeff Waldock
February 2003 		Homepages: ThumbHTML
Landscapeimage.com 		Revision history
Future plans


FileName: DSCN3338.JPG
FileSize: 538K
Make: NIKON
Model: E995
Date Original: 19/01/2003
Time Original: 14:23
Date Modified: 19/01/2003
Time Modified: 14:23
Width: 1280
Height: 960
Exposure: 1/57s
Focal Length: 22.9mm
Aperture: f4.2
Compression: 4/1
Metering: Multi-Segment
ISO: 100
Program: Program
Copyright:
EXIF Version: 0210
Image Number: 0
Comment: A hut at Bridlington!
Description:

FileName: DSCN3339.JPG
FileSize: 552K
Make: NIKON
Model: E995
Date Original: 19/01/2003
Time Original: 14:23
Date Modified: 19/01/2003
Time Modified: 14:23
Width: 1280
Height: 960
Exposure: 1/72s
Focal Length: 18.4mm
Aperture: f3.7
Compression: 4/1
Metering: Multi-Segment
ISO: 100
Program: Program
Copyright:
EXIF Version: 0210
Image Number: 0
Comment:
Description:

FileName: DSCN3340.JPG
FileSize: 517K
Make: NIKON
Model: E995
Date Original: 19/01/2003
Time Original: 14:33
Date Modified: 19/01/2003
Time Modified: 14:33
Width: 1280
Height: 960
Exposure: 1/175s
Focal Length: 8.2mm
Aperture: f3.7
Compression: 4/1
Metering: Multi-Segment
ISO: 100
Program: Program
Copyright:
EXIF Version: 0210
Image Number: 0
Comment: Grey day at the seaside
Description:

FileName: DSCN3341.JPG
FileSize: 479K
Make: NIKON
Model: E995
Date Original: 19/01/2003
Time Original: 14:33
Date Modified: 19/01/2003
Time Modified: 14:33
Width: 1280
Height: 960
Exposure: 1/60s
Focal Length: 29.3mm
Aperture: f4.9
Compression: 4/1
Metering: Multi-Segment
ISO: 100
Program: Program
Copyright:
EXIF Version: 0210
Image Number: 0
Comment:
Description:

FileName: DSCN3342.JPG
FileSize: 485K
Make: NIKON
Model: E995
Date Original: 19/01/2003
Time Original: 14:34
Date Modified: 19/01/2003
Time Modified: 14:34
Width: 1280
Height: 960
Exposure: 1/69s
Focal Length: 22.9mm
Aperture: f4.2
Compression: 4/1
Metering: Multi-Segment
ISO: 100
Program: Program
Copyright:
EXIF Version: 0210
Image Number: 0
Comment:
Description:

FileName: DSCN3343.JPG
FileSize: 464K
Make: NIKON
Model: E995
Date Original: 19/01/2003
Time Original: 16:09
Date Modified: 19/01/2003
Time Modified: 16:09
Width: 1280
Height: 960
Exposure: 1/170s
Focal Length: 9.6mm
Aperture: f4.0
Compression: 4/1
Metering: Multi-Segment
ISO: 100
Program: Program
Copyright:
EXIF Version: 0210
Image Number: 0
Comment: View of Bridlington beach
Description:

FileName: DSCN3344.JPG
FileSize: 496K
Make: NIKON
Model: E995
Date Original: 19/01/2003
Time Original: 16:09
Date Modified: 19/01/2003
Time Modified: 16:09
Width: 1280
Height: 960
Exposure: 1/109s
Focal Length: 31.0mm
Aperture: f5.1
Compression: 4/1
Metering: Multi-Segment
ISO: 100
Program: Program
Copyright:
EXIF Version: 0210
Image Number: 0
Comment:
Description:

FileName: DSCN3345.JPG
FileSize: 494K
Make: NIKON
Model: E995
Date Original: 19/01/2003
Time Original: 16:09
Date Modified: 19/01/2003
Time Modified: 16:09
Width: 1280
Height: 960
Exposure: 1/148s
Focal Length: 31.0mm
Aperture: f5.1
Compression: 4/1
Metering: Multi-Segment
ISO: 100
Program: Program
Copyright:
EXIF Version: 0210
Image Number: 0
Comment:
Description:

FileName: DSCN3346.JPG
FileSize: 524K
Make: NIKON
Model: E995
Date Original: 19/01/2003
Time Original: 16:27
Date Modified: 19/01/2003
Time Modified: 16:27
Width: 1280
Height: 960
Exposure: 1/171s
Focal Length: 8.2mm
Aperture: f4.2
Compression: 4/1
Metering: Multi-Segment
ISO: 100
Program: Program
Copyright:
EXIF Version: 0210
Image Number: 0
Comment:
Description:

FileName: DSCN3347.JPG
FileSize: 567K
Make: NIKON
Model: E995
Date Original: 19/01/2003
Time Original: 16:27
Date Modified: 19/01/2003
Time Modified: 16:27
Width: 1280
Height: 960
Exposure: 1/158s
Focal Length: 8.2mm
Aperture: f3.7
Compression: 4/1
Metering: Multi-Segment
ISO: 100
Program: Program
Copyright:
EXIF Version: 0210
Image Number: 0
Comment:
Description:

FileName: DSCN3348.JPG
FileSize: 509K
Make: NIKON
Model: E995
Date Original: 19/01/2003
Time Original: 16:28
Date Modified: 19/01/2003
Time Modified: 16:28
Width: 1280
Height: 960
Exposure: 1/124s
Focal Length: 26.9mm
Aperture: f4.6
Compression: 4/1
Metering: Multi-Segment
ISO: 100
Program: Program
Copyright:
EXIF Version: 0210
Image Number: 0
Comment:
Description:

FileName: DSCN3349.JPG
FileSize: 520K
Make: NIKON
Model: E995
Date Original: 19/01/2003
Time Original: 16:28
Date Modified: 19/01/2003
Time Modified: 16:28
Width: 1280
Height: 960
Exposure: 1/154s
Focal Length: 20.8mm
Aperture: f4.6
Compression: 4/1
Metering: Multi-Segment
ISO: 100
Program: Program
Copyright:
EXIF Version: 0210
Image Number: 0
Comment:
Description:

FileName: DSCN3350.JPG
FileSize: 525K
Make: NIKON
Model: E995
Date Original: 19/01/2003
Time Original: 16:28
Date Modified: 19/01/2003
Time Modified: 16:28
Width: 1280
Height: 960
Exposure: 1/213s
Focal Length: 11.5mm
Aperture: f4.8
Compression: 4/1
Metering: Multi-Segment
ISO: 100
Program: Program
Copyright:
EXIF Version: 0210
Image Number: 0
Comment:
Description:

FileName: DSCN3351.JPG
FileSize: 515K
Make: NIKON
Model: E995
Date Original: 19/01/2003
Time Original: 16:28
Date Modified: 19/01/2003
Time Modified: 16:28
Width: 1280
Height: 960
Exposure: 1/179s
Focal Length: 8.2mm
Aperture: f5.3
Compression: 4/1
Metering: Multi-Segment
ISO: 100
Program: Program
Copyright:
EXIF Version: 0210
Image Number: 0
Comment:
Description:

FileName: DSCN3352.JPG
FileSize: 461K
Make: NIKON
Model: E995
Date Original: 19/01/2003
Time Original: 16:28
Date Modified: 19/01/2003
Time Modified: 16:28
Width: 1280
Height: 960
Exposure: 1/210s
Focal Length: 8.2mm
Aperture: f4.7
Compression: 4/1
Metering: Multi-Segment
ISO: 100
Program: Program
Copyright:
EXIF Version: 0210
Image Number: 0
Comment:
Description:

FileName: DSCN3353.JPG
FileSize: 472K
Make: NIKON
Model: E995
Date Original: 19/01/2003
Time Original: 16:29
Date Modified: 19/01/2003
Time Modified: 16:29
Width: 1280
Height: 960
Exposure: 1/210s
Focal Length: 8.2mm
Aperture: f5.3
Compression: 4/1
Metering: Multi-Segment
ISO: 100
Program: Program
Copyright:
EXIF Version: 0210
Image Number: 0
Comment:
Description:

FileName: DSCN3354.JPG
FileSize: 517K
Make: NIKON
Model: E995
Date Original: 19/01/2003
Time Original: 16:29
Date Modified: 19/01/2003
Time Modified: 16:29
Width: 1280
Height: 960
Exposure: 1/324s
Focal Length: 8.2mm
Aperture: f6.0
Compression: 4/1
Metering: Multi-Segment
ISO: 100
Program: Program
Copyright:
EXIF Version: 0210
Image Number: 0
Comment:
Description:

FileName: DSCN3355.JPG
FileSize: 534K
Make: NIKON
Model: E995
Date Original: 19/01/2003
Time Original: 16:29
Date Modified: 19/01/2003
Time Modified: 16:29
Width: 1280
Height: 960
Exposure: 1/205s
Focal Length: 20.0mm
Aperture: f4.4
Compression: 4/1
Metering: Multi-Segment
ISO: 100
Program: Program
Copyright:
EXIF Version: 0210
Image Number: 0
Comment:
Description:

FileName: DSCN3356.JPG
FileSize: 454K
Make: NIKON
Model: E995
Date Original: 19/01/2003
Time Original: 16:30
Date Modified: 19/01/2003
Time Modified: 16:30
Width: 1280
Height: 960
Exposure: 1/198s
Focal Length: 8.2mm
Aperture: f5.3
Compression: 4/1
Metering: Multi-Segment
ISO: 100
Program: Program
Copyright:
EXIF Version: 0210
Image Number: 0
Comment:
Description:

FileName: DSCN3357.JPG
FileSize: 442K
Make: NIKON
Model: E995
Date Original: 19/01/2003
Time Original: 16:30
Date Modified: 19/01/2003
Time Modified: 16:30
Width: 1280
Height: 960
Exposure: 1/169s
Focal Length: 8.2mm
Aperture: f3.7
Compression: 4/1
Metering: Multi-Segment
ISO: 100
Program: Program
Copyright:
EXIF Version: 0210
Image Number: 0
Comment:
Description:

FileName: DSCN3358.JPG
FileSize: 434K
Make: NIKON
Model: E995
Date Original: 19/01/2003
Time Original: 16:31
Date Modified: 19/01/2003
Time Modified: 16:31
Width: 1280
Height: 960
Exposure: 1/140s
Focal Length: 8.2mm
Aperture: f3.3
Compression: 4/1
Metering: Multi-Segment
ISO: 100
Program: Program
Copyright:
EXIF Version: 0210
Image Number: 0
Comment:
Description:

FileName: DSCN3359.JPG
FileSize: 457K
Make: NIKON
Model: E995
Date Original: 19/01/2003
Time Original: 16:31
Date Modified: 19/01/2003
Time Modified: 16:31
Width: 1280
Height: 960
Exposure: 1/251s
Focal Length: 8.2mm
Aperture: f6.0
Compression: 4/1
Metering: Multi-Segment
ISO: 100
Program: Program
Copyright:
EXIF Version: 0210
Image Number: 0
Comment:
Description:

FileName: DSCN3360.JPG
FileSize: 480K
Make: NIKON
Model: E995
Date Original: 19/01/2003
Time Original: 16:32
Date Modified: 19/01/2003
Time Modified: 16:32
Width: 1280
Height: 960
Exposure: 1/225s
Focal Length: 31.0mm
Aperture: f5.8
Compression: 4/1
Metering: Multi-Segment
ISO: 100
Program: Program
Copyright:
EXIF Version: 0210
Image Number: 0
Comment:
Description:

FileName: DSCN3361.JPG
FileSize: 457K
Make: NIKON
Model: E995
Date Original: 19/01/2003
Time Original: 16:34
Date Modified: 19/01/2003
Time Modified: 16:34
Width: 1280
Height: 960
Exposure: 1/114s
Focal Length: 26.9mm
Aperture: f4.6
Compression: 4/1
Metering: Multi-Segment
ISO: 100
Program: Program
Copyright:
EXIF Version: 0210
Image Number: 0
Comment:
Description:

FileName: DSCN3362.JPG
FileSize: 455K
Make: NIKON
Model: E995
Date Original: 19/01/2003
Time Original: 16:34
Date Modified: 19/01/2003
Time Modified: 16:34
Width: 1280
Height: 960
Exposure: 1/145s
Focal Length: 26.9mm
Aperture: f4.6
Compression: 4/1
Metering: Multi-Segment
ISO: 100
Program: Program
Copyright:
EXIF Version: 0210
Image Number: 0
Comment:
Description:

FileName: DSCN3363.JPG
FileSize: 436K
Make: NIKON
Model: E995
Date Original: 19/01/2003
Time Original: 16:34
Date Modified: 19/01/2003
Time Modified: 16:34
Width: 1280
Height: 960
Exposure: 1/205s
Focal Length: 26.9mm
Aperture: f5.3
Compression: 4/1
Metering: Multi-Segment
ISO: 100
Program: Program
Copyright:
EXIF Version: 0210
Image Number: 0
Comment:
Description:


.topic 20000
Click this button to go to the subclassing form, where this works correctly.

.topic 20010
Click this button to go to the form which uses the standard VB6 technique, which does not work correctly.

.topic 2000
The EXIF data are exported to a data file called 'exifinfo.xls' in the current folder.  This file contains a header line, with the field names, followed by <i>n</i> lines of data, where <i>n</i> is the number of images containing EXIF data in the folder.


ThumbHTML - HTML Tab

HTML TAB
The "HTML" tab provides some extra options as follows:

  • Make HTML button
    Click this to generate the thumbnail and linked-image web pages.

  • View pages in browser
    This hyperlink is available if thumbnail pages exist in the current folder, and if clicked will load the index page into your default browser.

  • Images per page
    Select the number of image thumbnails to display on each page. If more than this number exist, then the program will create additional pages, called thumb2.html, thumb3.html etc, with links between them. Default is 20

  • Number of columns
    IF 'Table' is selected below, this determines the number of images across the screen. Default is 5

  • Table/Free form
    Choose whether to structure the thumbnail images in a table or whether to allow them to be rendered automatically, according to the browser width. Default is 'Table'.

  • HTML file extension
    Choose whether to use 'html' or 'htm' for all web page files. Default is '.html'

  • Include image number
    Check this to include the image number in the individual linked-image pages. Default is YES

  • Include image filename
    Check this to include the image filename in the individual linked-image pages. Default is YES

  • Include navigation buttons
    Check this to include the navigation icons in the individual linked-image pages. Default is YES

  • Include hyperlink to original image
    Check this to include the a link from the individual linked-image pages to your original (full-size) images. Default is YES

  • Include link to slideshow
    Click this to add a link from the individual pages to the slideshow (diabled if the slideshow file does not exist.. Default is YES

  • Include comments with thumbnails
    Check this to include picture comments with the thumbnails. Default is NO

  • Look for EXIF data in JPG images
    Check this to use data extracted from the EXIF headers of JPG files. Default is YES

  • Use file datestamp for time
    Check this to use the date and time of last modification of image files. Default is NO

  • Linked image popup in new window
    Check this to make linked image files appear in a new window. Default is NO

    • © Jeff Waldock


ThumbHTML - Settings Tab

SETTINGS TAB
The "Settings" tab provides some extra options as follows:

  • JPEG quality
    Choose a value for the quality (i.e. the compression) used when creating JPG files. Default is 95%

  • Progressive JPG
    Check this box if you want to create a JPG file that appears progressively as it is loaded rather than in a raster fashion (i.e. line-by-line). Note that this slows JPG creation down somewhat. Default is unchecked.

  • Remember Last Folder
    Check this box if you want to the program to recall the last folder used. Default is checked.

  • Date Format
    Select the date format required. If you choose 'other' then you can specify the format required in the text box, using the 'standard' d,m,y characters as placeholder for days, months and years. Changes should be implemented immediately in the EXIF data currently held by the system for the current folder. Default is European.

  • General Settings
    Here you can choose to auto-save the active profile settings (when changing profiles or when exiting the program) and whether or not to auto-load the last settings when re-starting the program. Default for both is checked.

  • Special Filter
    If this checkbox is enabled, ThumbHTML will use the filter chosen in the list below when resizing images, instead of the default setting. These filters can make a significant difference to the quality of the results, but in some cases the process is significantly slower. For an overview of the filters, and to see samples of the effects of each, take a look at this site (external link). Default is unchecked.

    • © Jeff Waldock


ThumbHTML - Slideshow Tab

SLIDESHOW TAB
The "HTML" tab provides some extra options as follows:

  • Make Slideshow button
    Click this to generate the thumbnail and linked-image web pages.

  • View slideshow in browser
    Hyperlink to display the slideshow in your default browser (disabled if no slideshow file exists).

  • Interval between images (sec)
    Enter the period each image is displayed for.

  • Transition time between images (sec)
    Enter the transition time between images in the slideshow.

  • Title
    Enter the slideshow title. If you have just created HTML pages this should have been filled in with the corresponding title from the HTML tab.

  • Slideshow filename
    Enter the slideshow filename.

  • Choose which images to use
    Select the folder containing the images to use in the slideshow. The default will be 'main', if this folder exists. If not, the original images in the root will be used.

  • Include photo comments
    Check this to include photo comments in the slideshow. Default is YES

  • Include date and time of images
    Check this to include the date and time of images in the slideshow. Default is YES

  • Add link from slideshow page to your index page
    Creates a link to the first thumbnail page. Default is YES

  • Include photo details
    Check this to include picture data in the slideshow. Default is YES

  • Include image count
    Check this to include the image count (e.g. x of xx) in the slideshow. Default is YES

  • Include filenames
    Check this to include photo filenames in the slideshow. Default is YES

    • © Jeff Waldock


ThumbHTML - Styles Tab

STYLES TAB
The "Styles" tab provides you with a means of choosing the colours of the main elements of the HTML pages generated by ThumbHTML.

  • "user-defined stylesheet" box is unchecked
    Colours are chosen by clicking on an element in the picture box and making a choice from the colour-picker that appears (there are two colour palettes available - 'web-safe', consisting of colours recognised by all browsers, and 'named colours', which consists of the named colours in Internet Explorer.

  • "user-defined stylesheet" box is checked
    In this case you define all attributes (including colours) by using a custom stylesheet. ThumbHTML uses a stylesheet called 'photos.css' that it creates in the root folder of your album, which is generated by the program in the above case (the 'user-defined stylesheet' box is unchecked). In this case, however, the photos.css file is copied from the stylesheet chosen in the list box on this tab.
    The program allows you to use the default template, or to create a new template (a copy of the default template is used as the starting point). You can edit and delete your added sheets using the buttons provided (editing or deleting the default stylesheet is not allowed).
    For help in determining what stylesheet elements correspond to the HTML elements, see the comments embedded in the stylesheet.
    • © Jeff Waldock


ThumbHTML - Thumbnail Tab

ThumbHTML TAB
The "Thumbnails" tab comprises three sections:
  1. Essentials
    Here you set the size of the 'thumbnails' required and the sub-folder to which they should be written.
    You can also choose to create same-size copies (100% box) - this will allow you to image process the originals.
    Finally, you can select which of the three image types to use, JPG, PNG and/or BMP.

  2. Drop Shadowing
    Suitable use of drop-shadows can considerably enhance the appearance of your web-based photo albums.
    The program allows you to do this by checking the appropriate box, and selecting a suitable blur level. You can also select an 'offset' - this is the number of pixels by which the shadow is displaced from the main image.
    Unless you want a 'sharp' shadow, you will need to blur it - the suggested figure is 75%.
    The colour used for the background of the shadowed image will be that selected from the colours tab for the background of the HTML pages. This is so that the shadowed image will look 'right' on the web page. Since only the thumb and main images are shown on web page backgrounds, it is not therefore advisable to create drop-shadows on any other resized images unless you are doing so for a particular purpose!

  3. Extras
    ThumbHTML version provides FOUR additional image processing features that you might find useful, if used sparingly.

    Sharpening | You can choose to sharpen resized images, by checking the checkbox. Select a sharpening amount (default 10%) - you will need to experiment to find the right level.
    Greyscale | This is a simple checkbox - when checked, ThumbHTML will generate monochrome images.
    Apply Tint | This allows you to add a coloured tint to your images. Works best when used in conjunction with monochrome images. The 'default' settings of 127 for Red, Green and Blue channels will have NO EFFECT! You must modify these!! Increase the red level to get a red tint, for example, but you will not need to do so by much. Click the 'Sepia' button to apply pre-defined settings which will generate a sepia tint.
    Border | You can add a border, choosing the size (in pixels) and the colour. Currently, this setting will not function if you also choose a drop-shadow - the drop-shadow will 'override' the border. Actually, it doesn't make a lot of sense to have both anyway.

As well as these features, the Thumbnails tab also contains a "Batch Process" button.
This will automatically generate folders containing images resized according to the current Batch settings.